#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <alloc.h>
#include <sys\stat.h>
#include <math.h>
#include "vardec.h"
#include "net.h"
#include "fcns.h"


int num_sys,num_sys_list,num_call_sys,num_ncn;
net_interconnect_rec *cnn;
net_call_out_rec *con;
net_system_list_rec *csn;
net_contact_rec *ncn;

extern int noklevel;

extern configrec syscfg;

void read_call_out_list()
{
  char s[161],b[256],s1[81],*ss;
  int f,i,i1,i2,n,cur_sys;
  long l,p;
  float fl;

  strcpy(s,syscfg.datadir);
  strcat(s,"CALLOUT.NET");
  f=open(s,O_RDWR | O_BINARY);
  if (f<0)
    con=NULL;
  else {
    l=filelength(f);
    if ((ss=malloca(l+512))==NULL)
      end_bbs(noklevel);
    read(f,(void *)ss,(int) l);
    close(f);
    num_call_sys=0;
    for (p=0L; p<l; p++)
      if (ss[p]=='@')
	++num_call_sys;
    farfree(ss);
    if ((con=malloca(((long)(num_call_sys+2))*sizeof(net_call_out_rec)))==NULL)
      end_bbs(noklevel);
    f=open(s,O_RDWR | O_BINARY);
    if ((ss=malloca(l+512))==NULL)
      end_bbs(noklevel);
    read(f,(void *)ss,(int) l);
    close(f);
    p=0L;
    cur_sys=-1;
    while (p<l) {
      while ((p<l) && (strchr("@%/\"&-=+~!()",ss[p])==NULL))
	++p;
      if (p<l) {
	switch(ss[p]) {
	  case '@':
	    ++p;
	    ++cur_sys;
	    con[cur_sys].macnum=0;
	    con[cur_sys].options=0;
	    con[cur_sys].call_anyway=0;
	    con[cur_sys].password[0]=0;
	    con[cur_sys].sysnum=atoi(&(ss[p]));
            con[cur_sys].min_hr=-1;
            con[cur_sys].max_hr=-1;
	    break;
          case '&':
	    con[cur_sys].options |= options_sendback;
	    ++p;
	    break;
          case '-':
	    con[cur_sys].options |= options_ATT_night;
	    ++p;
	    break;
          case '=':
	    con[cur_sys].options |= options_PCP_night;
	    ++p;
	    break;
          case '+':
	    con[cur_sys].options |= options_no_call;
	    ++p;
	    break;
	  case '~':
	    con[cur_sys].options |= options_receive_only;
	    ++p;
	    break;
	  case '!':
	    con[cur_sys].options |= options_once_per_day;
	    ++p;
	    break;
	  case '%':
	    ++p;
	    con[cur_sys].macnum=(unsigned char) atoi(&(ss[p]));
	    break;
	  case '/':
	    ++p;
	    con[cur_sys].call_anyway=(unsigned char) atoi(&(ss[p]));
	    break;
          case '(':
            ++p;
            con[cur_sys].min_hr = (unsigned char) atoi(&(ss[p]));
            break;
          case ')':
            ++p;
            con[cur_sys].max_hr = (unsigned char) atoi(&(ss[p]));
            break;
	  case '\"':
	    ++p;
	    i=0;
	    while ((i<40) && (ss[p+(long)i]!='"'))
	      ++i;
	    for (i1=0; i1<i; i1++)
	      con[cur_sys].password[i1]=ss[p+(long)i1];
	    con[cur_sys].password[i]=0;
	    p+=(long)(i+1);
	    break;
	}
      }
    }
    farfree(ss);
  }
}


void write_call_out_list()
{
  char s[161],b[256],s1[81],*ss;
  int f,i,i1,i2,n,cur_sys;
  long l,p;
  float fl;

  strcpy(s,syscfg.datadir);
  strcat(s,"CALLOUT.NET");
  f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  if (f>0) {
    for (i=0; i<num_call_sys; i++) {
      strcpy(s,"@");
      itoa(con[i].sysnum,s1,10);
      strcat(s,s1);
      while (strlen(s)<8)
	strcat(s," ");
      if (con[i].macnum) {
	strcat(s,"%");
	itoa((int)con[i].macnum,s1,10);
	strcat(s,s1);
	for (i1=strlen(s1); i1<4; i1++)
	  strcat(s," ");
      } else
	for (i1=0; i1<5; i1++)
	  strcat(s," ");
      if (con[i].call_anyway) {
	strcat(s,"/");
	itoa((int)con[i].call_anyway,s1,10);
	strcat(s,s1);
	for (i1=strlen(s1); i1<4; i1++)
	  strcat(s," ");
      } else
	for (i1=0; i1<5; i1++)
	  strcat(s," ");
      if (con[i].options & options_sendback)
        strcat(s,"& ");
      else
	strcat(s,"  ");
      if (con[i].options & options_ATT_night)
        strcat(s,"- ");
      else
	strcat(s,"  ");
      if (con[i].options & options_PCP_night)
         strcat(s,"= ");
      else
	strcat(s,"  ");
      if (con[i].options & options_no_call)
        strcat(s,"+ ");
      else
	strcat(s,"  ");
      if (con[i].options & options_receive_only)
	strcat(s,"~ ");
      else
	strcat(s,"  ");
      if (con[i].options & options_once_per_day)
	strcat(s,"! ");
      else
	strcat(s,"  ");
      if (con[i].min_hr>0) {
        strcat(s,"(");
        itoa((int)con[i].min_hr,s1,10);
	strcat(s,s1);
	for (i1=strlen(s1); i1<4; i1++)
	  strcat(s," ");
      } else
	for (i1=0; i1<5; i1++)
	  strcat(s," ");
      if (con[i].max_hr>0) {
        strcat(s,")");
        itoa((int)con[i].max_hr,s1,10);
	strcat(s,s1);
	for (i1=strlen(s1); i1<4; i1++)
	  strcat(s," ");
      } else
	for (i1=0; i1<5; i1++)
	  strcat(s," ");

      strcat(s,"  ");
      strcat(s,"\"");
      strcat(s,con[i].password);
      strcat(s,"\"\r\n");
      write(f,(void *)s,strlen(s));
    }
    close(f);
  }
}



void read_bbs_list()
{
  char s[161],b[256],s1[81],*ss;
  int f,i,i1,i2,i3,i4,n,cur_sys;
  long l,p;
  float fl;

  csn=NULL;
  cnn=NULL;
  con=NULL;
  num_sys=0;
  num_sys_list=0;
  num_call_sys=0;
  if (syscfg.systemnumber==0)
    return;
  strcpy(s,syscfg.datadir);
  strcat(s,"BBSDATA.NET");
  f=open(s,O_RDWR | O_BINARY);
  if (f>0) {
    l=filelength(f);
    num_sys_list=(int) (l/sizeof(net_system_list_rec));
    if ((csn=malloca(l+512L))==NULL)
      end_bbs(noklevel);
    read(f,(void *)csn,l);
    close(f);
    read_call_out_list();
  }
}


unsigned int next_system(unsigned int ts, float *cost1, int *nhops, char **s)
{
  unsigned int n;
  int i,csi;

  csi=-1;
  for (i=0; i<num_sys_list; i++)
    if (csn[i].sysnum==ts)
      csi=i;
  if (csi==-1) {
    *cost1=10000.0;
    n=65535;
    *nhops=10000;
  } else {
    *cost1=csn[csi].cost;
    n=csn[csi].forsys;
    *nhops=csn[csi].numhops;
    *s=csn[csi].name;
  }

  return(n);
}


void read_contacts()
{
  int i,f;
  char s[81];
  long l;

  if (ncn!=NULL)
    farfree(ncn);
  ncn=NULL;
  num_ncn=0;

  strcpy(s,syscfg.datadir);
  strcat(s,"CONTACT.NET");
  f=open(s,O_RDWR | O_BINARY);
  if (f>=0) {
    l=filelength(f);
    num_ncn=(int) (l/sizeof(net_contact_rec));
    if ((ncn=malloca((num_ncn+2)*sizeof(net_contact_rec)))==NULL)
      end_bbs(noklevel);
    lseek(f,0L,SEEK_SET);
    read(f,(void *)ncn,num_ncn*sizeof(net_contact_rec));
    close(f);
  }
}

