/*****************************************************************************

				WWIV Version 4
		      Copyright (C) 1988 by Wayne Bell

Distribution of the source code for WWIV, in any form, modified or unmodified,
without PRIOR, WRITTEN APPROVAL by the author, is expressly prohibited.
Distribution of compiled versions of WWIV is limited to copies compiled BY
THE AUTHOR.  Distribution of any copies of WWIV not compiled by the author
is expressly prohibited.


*****************************************************************************/



#include "vardec.h"
#include "fcns.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <time.h>


extern subboardrec subboards[32];
extern directoryrec directories[64];
extern int num_subs, num_dirs,hangup,userfile,echo,useron,wfc,userfile,usernum;
extern int incom,fwaiting;
extern configrec syscfg;
extern statusrec status;
extern char ctypes[NUM_CTYPES][18];
extern char cdir[81];
extern userrec thisuser;
extern int numextrn, numchain;
extern chainfilerec *chains;
extern externalrec *externs;
extern unsigned char agemin,agemax,slmin,slmax,dslmin,dslmax,ressex;
extern int daysmin,daysmax,lecho;
extern unsigned short arres,darres,resres;
extern int questused[20];
extern unsigned char realsl;


void deluser(int un)
{
  userrec u;
  int i,i1,f,n;
  mailrec m;
  char fn[81];
  votingrec v;
  voting_response vr;

  read_user(un,&u);
  if ((u.inact & inact_deleted)==0) {
    rsm(un,&u);
    dsr(u.name);
    u.inact |= inact_deleted;
    u.waiting=0;
    write_user(un,&u);
    strcpy(fn,syscfg.datadir);
    strcat(fn,"EMAIL.DAT");
    f=open(fn,O_RDWR | O_BINARY, S_IREAD | S_IWRITE);
    if (f>0) {
      i1=filelength(f)/sizeof(mailrec);
      for (i=0; i<i1; i++) {
        lseek(f,((long) i) * sizeof(mailrec), SEEK_SET);
        read(f,(void *)(&m),sizeof(mailrec));
        if (((m.tosys==0) && (m.touser==un)) ||
            ((m.fromsys==0) && (m.fromuser==un))) {
          delmail(f,i);
        }
      }
    }
    close(f);
    strcpy(fn,syscfg.datadir);
    strcat(fn,"VOTING.DAT");
    f=open(fn,O_RDWR | O_BINARY, S_IREAD | S_IWRITE);
    n=(int) (filelength(f) / sizeof(votingrec)) -1;
    for (i=0; i<20; i++)
      if (u.votes[i]) {
        if (i<=n) {
          lseek(f,((long) i) * sizeof(votingrec), SEEK_SET);
          read(f,(void *)&v,sizeof(votingrec));
          vr=v.responses[u.votes[i]-1];
          vr.numresponses--;
          v.responses[u.votes[i]-1]=vr;
          lseek(f,((long) i) * sizeof(votingrec), SEEK_SET);
          write(f,(void *)&v,sizeof(votingrec));
        }
        u.votes[i]=0;
      }
    write_user(un,&u);
    close(f);
  }
}


int checkpw()
{
  char s[81];

  nl();
  prt(2,"SY: ");
  echo=0;
  input(s,20);
  echo=1;
  if (strcmp(s,(syscfg.systempw))==0)
    return(1);
  else
    return(0);
}


void boarddata(int n, char *s)
{
  char x,y,k,i;
  subboardrec r;

  r=subboards[n];
  if (r.ar==0)
    x=32;
  else {
    for (i=0; i<16; i++)
      if ((1 << i) & r.ar)
        x='A'+i;
  }
  switch(r.anony) {
    case 0: y='N'; break;
    case anony_enable_anony: y='Y'; break;
    case anony_enable_dear_abby: y='D'; break;
    case anony_force_anony: y='F'; break;
  }
  if (r.key==0)
    k=32;
  else
    k=r.key;
  sprintf(s,"%2d %1c %1c  %-40s  %-8s %-3d %-3d %-3d %-3d %1c",
            n,k,x,r.name,r.filename,r.readsl,r.postsl,r.age,r.maxmsgs,y);
}

void showsubs()
{
  int abort,i;
  char s[180];

  outchr(12);
  abort=0;
  pla("NN K AR Name                                      FN       RSL PSL AGE MSG ANON",
      &abort);
  pla("== - == ----------------------------------------  ======== --- === --- === ----",
      &abort);
  for (i=0; (i<num_subs) && (!abort); i++) {
    boarddata(i,s);
    pla(s,&abort);
  }
}



void modify_sub(int n)
{
  subboardrec r;
  char s[81],s1[81],ch,ch2;
  int i,i1,done;

  r=subboards[n];
  done=0;
  do {
    outchr(12);
    print("A. Name       : ",r.name,"");
    print("B. Filename   : ",r.filename,"");
    if (r.key==0)
      strcpy(s,"None");
    else {
      s[0]=r.key;
      s[1]=0;
    }
    print("C. Key        : ",s,"");
    itoa(r.readsl,s,10);
    print("D. Read SL    : ",s,"");
    itoa(r.postsl,s,10);
    print("E. Post SL    : ",s,"");
    switch(r.anony) {
      case 0: strcpy(s,"No."); break;
      case anony_enable_anony: strcpy(s,"Yes."); break;
      case anony_enable_dear_abby: strcpy(s,"Dear Abby."); break;
      case anony_force_anony: strcpy(s,"Forced."); break;
    }
    print("F. Anony      : ",s,"");
    itoa(r.age,s,10);
    print("G. Min. Age   : ",s,"");
    itoa(r.maxmsgs,s,10);
    print("H. Max Msgs   : ",s,"");
    strcpy(s,"None.");
    if (r.ar!=0) {
      for (i=0; i<16; i++)
        if ((1 << i) & r.ar)
          s[0]='A'+i;
      s[1]=0;
    }
    print("I. AR         : ",s,"");
    ltoa((unsigned long) r.type,s,10);
    print("J. Sub Type   : ",s,"");
    itoa(r.storage_type,s,10);
    print("K. Storage typ: ",s,"");
    nl();
    prt(2,"Which (A-K,Q) ? ");
    ch=onek("QABCDEFGHIJK");
    switch(ch) {
      case 'Q':done=1; break;
      case 'A':
        nl();
        prt(2,"New Name? ");
        inputl(s,40);
        if (s[0])
          strcpy(r.name,s);
        break;
      case 'B':
        nl();
        prt(2,"New Filename? ");
        input(s,8);
        if ((s[0]!=0) && (strchr(s,'.')==0))
          strcpy(r.filename,s);
        break;
      case 'C':
        nl();
        prt(2,"New Key (spc=none) ? ");
        ch2=onek("@#$%^&()-_=+\\|][{};:'\",<>`~ ");
        if (ch2==32)
          r.key=0;
        else
          r.key=ch2;
        break;
      case 'D':
        nl();
        prt(2,"New Read SL? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<256) && (s[0]))
          r.readsl=i;
        break;
      case 'E':
        nl();
        prt(2,"New Post SL? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<256) && (s[0]))
          r.postsl=i;
        break;
      case 'F':
        nl();
        prt(2,"New Anony (Y,N,D,F) ? ");
        ch2=onek("NYDF");
        switch(ch2) {
          case 'N': r.anony=0; break;
          case 'Y': r.anony=anony_enable_anony; break;
          case 'D': r.anony=anony_enable_dear_abby; break;
          case 'F': r.anony=anony_force_anony; break;
        }
        break;
      case 'G':
        nl();
        prt(2,"New Min Age? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<128) && (s[0]))
          r.age=i;
        break;
      case 'H':
        nl();
        prt(2,"New Max Msgs? ");
        input(s,3);
        i=atoi(s);
        if ((i>0) && (i<255) && (s[0]))
          r.maxmsgs=i;
        break;
      case 'I':
        nl();
        prt(2,"New AR (<SPC>=None) ? ");
        ch2=onek("ABCDEFGHIJKLMNOP ");
        if (ch2==32)
          r.ar=0;
        else
          r.ar=1 << (ch2-'A');
        break;
      case 'J':
        nl();
        prt(2,"New Sub Type? ");
        input(s,5);
        i=atoi(s);
        if (s[0])
          r.type=i;
        break;
      case 'K':
        nl();
        prt(2,"New Storage Type (0,1,2) ? ");
        input(s,4);
        i=atoi(s);
        if ((s[0]) && (i>=0) && (i<=2))
          r.storage_type=i;
        break;
    }
  } while ((!done) && (!hangup));
  subboards[n]=r;
  if (!wfc)
    changedsl();
}


void insert_sub(int n)
{
  subboardrec r;
  int i,i1,nu;
  userrec u;
  long l1,l2,l3;

  for (i=num_subs-1; i>=n; i--)
    subboards[i+1]=subboards[i];
  strcpy(r.name,"** NEW SUB **");
  strcpy(r.filename,"NONAME");
  r.key=0;
  r.readsl=10;
  r.postsl=20;
  r.anony=0;
  r.age=0;
  r.maxmsgs=50;
  r.ar=0;
  r.type=0;
  r.storage_type=2;
  subboards[n]=r;
  ++num_subs;
  read_user(1,&u);
  nu=(int) (filelength(userfile) / sizeof(userrec));
  l1=0xffffffff >>(32-n);
  l2=0xffffffff <<(n+1);
  l3=1L << n;
  for (i=1; i<nu; i++) {
    read_user(i,&u);
    if (u.sysopsub!=255)
      if (u.sysopsub>=n)
        ++u.sysopsub;
    for (i1=num_subs-1; i1>n; i1--)
      u.qscnptr[i1]=u.qscnptr[i1-1];
    u.qscnptr[n]=0L;
    u.qscn=(u.qscn & l1) | ((u.qscn << 1) & l2) | l3;
    write_user(i,&u);
  }
  modify_sub(n);
}


void delete_sub(int n)
{
  int i,i1,nu;
  userrec u;
  long l1,l2;

  for (i=n; i<num_subs; i++)
    subboards[i]=subboards[i+1];
  --num_subs;
  read_user(1,&u);
  nu=(int) (filelength(userfile) / sizeof(userrec));
  l1=0xffffffff >>(32-n);
  l2=0xffffffff <<(n);
  for (i=1; i<nu; i++) {
    read_user(i,&u);
    if (u.sysopsub==n)
      u.sysopsub=255;
    else
      if ((u.sysopsub>n) && (u.sysopsub!=255))
        --u.sysopsub;
    for (i1=n; i1<num_subs; i1++)
      u.qscnptr[i1]=u.qscnptr[i1+1];
    u.qscnptr[31]=0L;
    u.qscn=(u.qscn & l1) | ((u.qscn >> 1) & l2);
    write_user(i,&u);
  }
  if (!wfc)
    changedsl();
}


void boardedit()
{
  int i,i1,i2,done,f;
  char s[81],s1[81],s2[81],ch;

  if (!checkpw())
    return;
  showsubs();
  done=0;
  do {
    nl();
    prt(2,"Subs: D:elete, I:nsert, M:odify, Q:uit, ? : ");
    ch=onek("QDIM?");
    switch(ch) {
      case '?':
        showsubs();
        break;
      case 'Q':
        done=1;
        break;
      case 'M':
        nl();
        prt(2,"Sub number? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<num_subs))
          modify_sub(i);
        break;
      case 'I':
        if (num_subs<32) {
          nl();
          prt(2,"Insert before which sub? ");
          input(s,2);
          i=atoi(s);
          if ((s[0]!=0) && (i>=0) && (i<=num_subs))
            insert_sub(i);
        }
        break;
      case 'D':
        nl();
        prt(2,"Delete which sub? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<num_subs)) {
          nl();
          sprintf(s1,"Delete %s? ",subboards[i].name);
          prt(5,s1);
          if (yn())
            delete_sub(i);
        }
        break;
    }
  } while ((!done) && (!hangup));
  strcpy(s,syscfg.datadir);
  strcat(s,"SUBS.DAT");
  f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(f,(void *)&subboards[0], num_subs * sizeof(subboardrec));
  close(f);
}

void dirdata(int n, char *s)
{
  char x,y,k,i;
  directoryrec r;

  r=directories[n];
  if (r.dar==0)
    x=32;
  else {
    for (i=0; i<16; i++)
      if ((1 << i) & r.dar)
        x='A'+i;
  }
  sprintf(s,"%2d  %1c  %-40s  %-8s %-3d %-3d %-3d %-9.9s",
            n,x,r.name,r.filename,r.dsl,r.age,r.maxfiles,r.path);
}

void showdirs()
{
  int abort,i;
  char s[180];

  outchr(12);
  abort=0;
  pla("NN DAR Name                                      FN       DSL AGE FIL PATH",
      &abort);
  pla("== --- ========================================  -------- === --- === ---------",
      &abort);
  for (i=0; (i<num_dirs) && (!abort); i++) {
    dirdata(i,s);
    pla(s,&abort);
  }
}



void modify_dir(int n)
{
  directoryrec r;
  char s[81],s1[81],ch,ch2;
  int i,i1,done;

  r=directories[n];
  done=0;
  do {
    outchr(12);
    print("A. Name       : ",r.name,"");
    print("B. Filename   : ",r.filename,"");
    print("C. Path       : '",r.path,"'","");
    itoa(r.dsl,s,10);
    print("D. DSL        : ",s,"");
    itoa(r.age,s,10);
    print("E. Min. Age   : ",s,"");
    itoa(r.maxfiles,s,10);
    print("F. Max Files  : ",s,"");
    strcpy(s,"None.");
    if (r.dar!=0) {
      for (i=0; i<16; i++)
        if ((1 << i) & r.dar)
          s[0]='A'+i;
      s[1]=0;
    }
    print("G. DAR        : ",s,"");
    itoa(r.mask,s,2);
    print("H. Mask       : ",s,"");
    itoa(r.type,s,10);
    print("I. Dir Type   : ",s,"");
    if (r.mask & mask_no_uploads)
       pl("J. Uploads    : Disallowed");
    else
       pl("J. Uploads    : Allowed");
    nl();
    prt(2,"Which (A-J,Q) ? ");
    ch=onek("QABCDEFGHIJ");
    switch(ch) {
      case 'Q':done=1; break;
      case 'A':
        nl();
        prt(2,"New Name? ");
        inputl(s,40);
        if (s[0])
          strcpy(r.name,s);
        break;
      case 'B':
        nl();
        prt(2,"New Filename? ");
        input(s,8);
        if ((s[0]!=0) && (strchr(s,'.')==0))
          strcpy(r.filename,s);
        break;
      case 'C':
        nl();
        pl("Enter new path, optionally with drive specifier.");
        pl("No backslash on end.");
        prt(2,"New Path? ");
        input(s,80);
        if (s[0]) {
          if (chdir(s)) {
            chdir(cdir);
            if (mkdir(s)) {
              pl("Unable to create or change to directory.");
              pl("Hit any key.");
              getkey();
              s[0]=0;
            }
          } else {
            chdir(cdir);
          }
          if (s[0]) {
            strcat(s,"\\");
            strcpy(r.path,s);
            pl("Path for directory changed.");
            pl("If there are any files in it, you must");
            pl("manually move them to the new directory.");
            pl("Hit any key.");
            getkey();
          }
        }
        break;
      case 'D':
        nl();
        prt(2,"New DSL? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<256) && (s[0]))
          r.dsl=i;
        break;
      case 'E':
        nl();
        prt(2,"New Min Age? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<128) && (s[0]))
          r.age=i;
        break;
      case 'F':
        nl();
        prt(2,"New Max files? ");
        input(s,3);
        i=atoi(s);
        if ((i>0) && (i<500) && (s[0]))
          r.maxfiles=i;
        break;
      case 'G':
        nl();
        prt(2,"New DAR (<SPC>=None) ? ");
        ch2=onek("ABCDEFGHIJKLMNOP ");
        if (ch2==32)
          r.dar=0;
        else
          r.dar=1 << (ch2-'A');
        break;
      case 'H':
        nl();
        prt(2,"New Mask? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<32767) && (s[0]))
          r.mask=i;
        break;
      case 'I':
        nl();
        prt(2,"New Dir Type? ");
        input(s,4);
        i=atoi(s);
        if (s[0])
          r.type=i;
        break;
      case 'J':
        r.mask &= ~mask_no_uploads;
        nl();
        prt(5,"Allow uploads to this directory? ");
        if (!ny())
          r.mask |= mask_no_uploads;
        break;
    }
  } while ((!done) && (!hangup));
  directories[n]=r;
  if (!wfc)
    changedsl();
}


void insert_dir(int n)
{
  directoryrec r;
  int i,i1,nu;
  userrec u;
  long l1,l2,l3;

  for (i=num_dirs-1; i>=n; i--)
    directories[i+1]=directories[i];
  strcpy(r.name,"** NEW DIR **");
  strcpy(r.filename,"NONAME");
  strcpy(r.path,syscfg.dloadsdir);
  r.dsl=10;
  r.age=0;
  r.maxfiles=50;
  r.dar=0;
  r.type=0;
  r.mask=0;
  directories[n]=r;
  ++num_dirs;
  read_user(1,&u);
  nu=(int) (filelength(userfile) / sizeof(userrec));
  if (n>=32) {
    l1=0xffffffff >>(64-n);
    l2=0xffffffff <<(n-31);
    l3=1L << (n-32);
    for (i=1; i<nu; i++) {
      read_user(i,&u);
      u.nscn2=(u.nscn2 & l1) | ((u.nscn2 << 1) & l2) | l3;
      write_user(i,&u);
    }
  } else {
    l1=0xffffffff >>(32-n);
    l2=0xffffffff <<(n+1);
    l3=1L << n;
    for (i=1; i<nu; i++) {
      read_user(i,&u);
      u.nscn2=(u.nscn2 << 1) | (u.nscn1 >> 31);
      u.nscn1=(u.nscn1 & l1) | ((u.nscn1 << 1) & l2) | l3;
      write_user(i,&u);
    }
  }
  modify_dir(n);
}


void delete_dir(int n)
{
  int i,i1,nu;
  userrec u;
  long l1,l2;

  for (i=n; i<num_dirs; i++)
    directories[i]=directories[i+1];
  --num_dirs;
  read_user(1,&u);
  nu=(int) (filelength(userfile) / sizeof(userrec));
  if (n>=32) {
    l1=0xffffffff >>(64-n);
    l2=0xffffffff <<(n-32);
    for (i=1; i<nu; i++) {
      read_user(i,&u);
      u.nscn2=(u.nscn2 & l1) | ((u.nscn2 >> 1) & l2);
      write_user(i,&u);
    }
  } else {
    l1=0xffffffff >>(32-n);
    l2=0xffffffff <<(n);
    for (i=1; i<nu; i++) {
      read_user(i,&u);
      u.nscn1=(u.nscn1 & l1) | ((u.nscn1 >> 1) & l2) | (u.nscn2 << 31);
      u.nscn2=u.nscn2 >> 1;
      write_user(i,&u);
    }
  }
  if (!wfc)
    changedsl();
}


void dlboardedit()
{
  int i,i1,i2,done,f;
  char s[81],s1[81],s2[81],ch;

  if (!checkpw())
    return;
  showdirs();
  done=0;
  do {
    nl();
    prt(2,"Dirs: D:elete, I:nsert, M:odify, Q:uit, ? : ");
    ch=onek("QDIM?");
    switch(ch) {
      case '?':
        showdirs();
        break;
      case 'Q':
        done=1;
        break;
      case 'M':
        nl();
        prt(2,"Dir number? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<num_dirs))
          modify_dir(i);
        break;
      case 'I':
        if (num_dirs<64) {
          nl();
          prt(2,"Insert before which dir? ");
          input(s,2);
          i=atoi(s);
          if ((s[0]!=0) && (i>=0) && (i<=num_dirs))
            insert_dir(i);
        }
        break;
      case 'D':
        nl();
        prt(2,"Delete which dir? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<num_dirs)) {
          nl();
          sprintf(s1,"Delete %s? ",directories[i].name);
          prt(5,s1);
          if (yn())
            delete_dir(i);
        }
        break;
    }
  } while ((!done) && (!hangup));
  strcpy(s,syscfg.datadir);
  strcat(s,"DIRS.DAT");
  f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(f,(void *)&directories[0], num_dirs * sizeof(directoryrec));
  close(f);
}



void print_data(int un, userrec *u)
{
  char s[81],s1[81],s2[81],s3[81],s4[81];
  int i;

  outchr(12);
  if ((u->inact) & inact_deleted) {
    pl(">>> DELETED <<<");
    nl();
  }
  print("Name: ",nam(u,un),"");
  print("RN  : ",(u->realname),"");
  if ((u->callsign[0])!=0)
    print("Call: ",(u->callsign),"");
  print("PH  : ",(u->phone),"");
  itoa(u->age,s,10);
  s1[0]=32;
  s1[1]=u->sex;
  s1[2]=0;
  print("Age : ",s,s1,"");
  strcpy(s,"PW  : ");
  strcat(s,(u->pw));
  strcat(s,"\r\n");
  if (lecho)
    outs(s);
  if ((incom) && (realsl==255))
    pr1(s);
  print("Comp: ",&(ctypes[u->comp_type][0]),"");
  print("Last: ",(u->laston),"   ",(u->firston),"");
  itoa(u->msgpost,s1,10);
  itoa(u->emailsent,s2,10);
  itoa(u->feedbacksent,s3,10);
  itoa(u->waiting,s,10);
  itoa(u->emailnet,s4,10);
  if (u->emailnet)
    print("Msgs: P=",s1," E=",s2," F=",s3," W=",s," O=",s4,"");
  else
    print("Msgs: P=",s1," E=",s2," F=",s3," W=",s,"");
  itoa(u->logons,s1,10);
  if (strcmp((u->laston),date())==0)
    itoa(u->ontoday,s2,10);
  else
    itoa(0,s2,10);
  itoa(u->illegal,s3,10);
  print("Log : ",s1,"  ",s2,"  I=",s3,"");
  itoa(u->uploaded,s,10);
  itoa(u->downloaded,s1,10);
  ltoa(u->uk,s2,10);
  ltoa(u->dk,s3,10);
  print("UpDn: U=",s,"-",s2,"k   D=",s1,"-",s3,"k","");
  if (u->note[0])
    print("Note: ",(u->note),"");
  if (u->ass_pts){
    itoa(u->ass_pts,s,10);
    print("Ass : ",s,"");
  }
  nl();
  itoa(u->sl,s,10);
  itoa(u->dsl,s1,10);
  print("SL  : ",s,"  DSL=",s1,"");
  if ((u->sysopsub)!=255){
    itoa(u->sysopsub,s,10);
    print("SySu: ",s,"");
  }
  if (u->exempt) {
    itoa(u->exempt,s,10);
    print("Exem: ",s,"");
  }
  strcpy(s3,restrict_string);
  for (i=0; i<=15; i++) {
    if (u->ar & (1 << i))
      s[i]='A'+i;
    else
      s[i]=32;
    if (u->dar & (1 << i))
      s1[i]='A'+i;
    else
      s1[i]=32;
    if (u->restrict & (1 << i))
      s2[i]=s3[i];
    else
      s2[i]=32;
  }
  s[16]=0;
  s1[16]=0;
  s2[16]=0;
  if ((u->ar)!=0)
    print("AR  : ",s,"");
  if ((u->dar)!=0)
    print("DAR : ",s1,"");
  if ((u->restrict)!=0)
    print("Rest: ",s2,"");
}


void print_short(int un, userrec *u)
{
  char s[81],s1[81],s2[81],s3[81];
  int i;

  outchr(12);
  if ((u->inact) & inact_deleted) {
    pl(">>> DELETED <<<");
    nl();
  }
  print("Name: ",nam(u,un),"");
  print("RN  : ",(u->realname),"");
  print("PH  : ",(u->phone),"");
  itoa(u->age,s,10);
  s1[0]=32;
  s1[1]=u->sex;
  s1[2]=0;
  print("Age : ",s,s1,"");
  print("Comp: ",&(ctypes[u->comp_type][0]),"");
  if (u->note[0])
    print("Note: ",(u->note),"");
  if (u->ass_pts){
    itoa(u->ass_pts,s,10);
    print("Ass : ",s,"");
  }
  nl();
  itoa(u->sl,s,10);
  itoa(u->dsl,s1,10);
  print("SL  : ",s,"  DSL=",s1,"");
  if ((u->sysopsub)!=255){
    itoa(u->sysopsub,s,10);
    print("SySu: ",s,"");
  }
  if (u->exempt) {
    itoa(u->exempt,s,10);
    print("Exem: ",s,"");
  }
  strcpy(s3,restrict_string);
  for (i=0; i<=15; i++) {
    if (u->ar & (1 << i))
      s[i]='A'+i;
    else
      s[i]=32;
    if (u->dar & (1 << i))
      s1[i]='A'+i;
    else
      s1[i]=32;
    if (u->restrict & (1 << i))
      s2[i]=s3[i];
    else
      s2[i]=32;
  }
  s[16]=0;
  s1[16]=0;
  s2[16]=0;
  if ((u->ar)!=0)
    print("AR  : ",&s,"");
  if ((u->dar)!=0)
    print("DAR : ",&s1,"");
  if ((u->restrict)!=0)
    print("Rest: ",&s2,"");
}


int matchuser(int un)
{
  userrec u;
  int ok;
  long l;
  unsigned int d;

  read_user(un,&u);
  ok=1;

  if ((u.age>agemax) || (u.age<agemin))
    ok=0;
  if ((u.sl>slmax) || (u.sl<slmin))
    ok=0;
  if ((u.dsl>dslmax) || (u.dsl<dslmin))
    ok=0;
  if (ressex)
    if (u.sex!=ressex)
      ok=0;
  if (arres)
    if ((u.ar & arres)==0)
      ok=0;
  if (darres)
    if ((u.dar & darres)==0)
      ok=0;
  time(&l);
  d=(unsigned int)( (l-u.daten)/24.0/3600.0 );
  if ((d>daysmax) || (d<daysmin))
    ok=0;

  return(ok);
}


void changeopt()
{
  int done,i,i1;
  char s[81],s1[81],s2[81],s3[81],ch;

  done=0;
  do {
    outchr(12);
    itoa(slmin,s,10);
    itoa(slmax,s1,10);
    print("1. SL     : ",s," to ",s1,"");
    itoa(dslmin,s,10);
    itoa(dslmax,s1,10);
    print("2. DSL    : ",s," to ",s1,"");
    itoa(agemin,s,10);
    itoa(agemax,s1,10);
    print("3. AGE    : ",s," to ",s1,"");
    itoa(daysmin,s,10);
    itoa(daysmax,s1,10);
    print("4. Last On: ",s," to ",s1," days ago","");
    if (ressex) {
      s[0]=ressex;
      s[1]=0;
      print("5. Sex    : ",s,"");
    } else
      print("5. Sex    : Inactive","");
    s[0]=0;
    s[1]=0;
    s1[0]=0;
    s1[1]=0;
    for (i=0; i<16; i++) {
      if ((1 << i) & arres)
        s[0]='A'+i;
      if ((1 << i) & darres)
        s1[0]='A'+i;
    }
    if (s[0])
      print("6. AR     : ",s,"");
    else
      print("6. AR     : Inactive","");
    if (s1[0])
      print("7. DAR    : ",s1,"");
    else
      print("7. DAR    : Inactive","");
    nl();
    prt(2,"Search Options (1-7,Q) : ");
    ch=onek("Q1234567");
    nl();
    switch(ch) {
      case 'Q':
        done=1;
        break;
      case '1':
        prt(2,"Min SL? ");
        input(s,3);
        if (s[0])
          slmin=atoi(s);
        prt(2,"Max SL? ");
        input(s,3);
        if (s[0])
          slmax=atoi(s);
        break;
      case '2':
        prt(2,"Min DSL? ");
        input(s,3);
        if (s[0])
          dslmin=atoi(s);
        prt(2,"Max DSL? ");
        input(s,3);
        if (s[0])
          dslmax=atoi(s);
        break;
      case '3':
        prt(2,"Min age? ");
        input(s,3);
        if (s[0])
          agemin=atoi(s);
        prt(2,"Max age? ");
        input(s,3);
        if (s[0])
          agemax=atoi(s);
        break;
      case '4':
        prt(2,"Min days since logon? ");
        input(s,4);
        if (s[0])
          daysmin=atoi(s);
        prt(2,"Max days since logon? ");
        input(s,4);
        if (s[0])
          daysmax=atoi(s);
        break;
      case '5':
        prt(2,"Sex restrict (spc=none) ? ");
        ressex=onek(" MF");
        if (ressex==32)
          ressex=0;
        break;
      case '6':
        prt(2,"AR restrict (spc=none) ? ");
        s[0]=onek(" ABCDEFGHIJKLMNOP");
        if (s[0])
          arres=1 << (s[0]-'A');
        else
          arres=0;
        break;
      case '7':
        prt(2,"DAR restrict (spc=none) ? ");
        s[0]=onek(" ABCDEFGHIJKLMNOP");
        if (s[0])
          darres=1 << (s[0]-'A');
        else
          darres=0;
        break;
    }
  } while ((!done) && (!hangup));
}


#pragma warn -par

void uedit(int usern, int other)
{
  char s[81],s1[81],s2[81],ch,ch1;
  int i,i1,i2,i3,un,done,nu,done1,full,temp_full,tempu;
  userrec u;

  if (incom)
    full=0;
  else
    full=1;
  un=usern;
  done=0;
  read_user(un,&u);
  nu=(int) (filelength(userfile) / sizeof(userrec)) - 1;
  do {
    read_user(un,&u);
    done1=0;
    temp_full=0;
    do {
      if ((full) || (temp_full))
        print_data(un,&u);
      else
        print_short(un,&u);
      nl();
      prt(2,"Uedit : ");
      if ((realsl==255) || (wfc))
	ch=onek("Q[]{}/,.?UDRNLCPOGMSTEYZAIW~:");
      else
        ch=onek("Q[]{}/,.?UDRNLCPOGMSTEYZAI");
      switch(ch) {
        case 'Q':
          done=1;
          done1=1;
          break;
        case ']':
          ++un;
          if (un>nu)
            un=1;
          done1=1;
          break;
        case '[':
          --un;
          if (un==0)
            un=nu;
          done1=1;
          break;
        case '/':
          changeopt();
          break;
        case '}':
          tempu=un;
          ++un;
          if (un>nu)
            un=1;
          while ((un!=tempu) && (!matchuser(un))) {
            ++un;
            if (un>nu)
              un=1;
          }
          done1=1;
          break;
        case '{':
          tempu=un;
          --un;
          if (un<1)
            un=nu;
          while ((un!=tempu) && (!matchuser(un))) {
            --un;
            if (un<1)
              un=nu;
          }
          done1=1;
          break;
        case '.':
          full=(!full);
          temp_full=full;
          break;
        case ',':
          temp_full=(!temp_full);
          break;
        case '?':
          printmenu(6);
          getkey();
          break;
        case 'D':
          if (((u.inact & inact_deleted)==0) && (thisuser.sl>u.sl)) {
            prt(5,"Delete? ");
            if (yn()) {
              deluser(un);
              read_user(un,&u);
            }
          }
          break;
        case 'R':
          if (u.inact & inact_deleted) {
            u.inact ^= inact_deleted;
            isr(un,u.name);
            write_user(un,&u);
          }
          break;
        case 'U':
          nl();
          prt(2,"User name/number: ");
          input(s,30);
          i=finduser1(s);
          if (i>0) {
            un=i;
            done1=1;
          }
          break;
        case 'N':
          nl();
          prt(2,"New name? ");
          input(s,30);
          if (s[0]) {
            if (finduser(s)<1) {
              dsr(u.name);
              strcpy(u.name,s);
              isr(un,u.name);
              write_user(un,&u);
            }
          }
          break;
        case 'L':
          nl();
          prt(2,"New real name? ");
          inputl(s,20);
          if (s[0]) {
            strcpy(u.realname,s);
            write_user(un,&u);
          }
          break;
        case 'C':
          nl();
          prt(2,"New callsign? ");
          input(s,6);
          if (s[0]) {
            strcpy(u.callsign,s);
            write_user(un,&u);
          } else {
            prt(5,"Delete callsign? ");
            if (yn()) {
              u.callsign[0]=0;
              write_user(un,&u);
            }
          }
          break;
        case 'P':
          nl();
          prt(2,"New phone number? ");
          input(s,12);
          if (s[0]) {
            strcpy(u.phone,s);
            write_user(un,&u);
          }
          break;
        case 'O':
          nl();
          prt(2,"New note? ");
          inputl(s,39);
          strcpy(u.note,s);
          write_user(un,&u);
          break;
        case 'G':
          nl();
          sprintf(s,"Current birthdate: %02d/%02d/%02d",(int) u.month,
	         (int) u.day,
                 (int) u.year);
          pl(s);
          input_age(&u);
          write_user(un,&u);
          break;
        case 'M':
          nl();
          pl("Known computer types:");
          nl();
          for (i=0; i<NUM_CTYPES; i++)
            print(itoa(i+1,s,10),". ",ctypes[i],"");
          nl();
          prt(2,"Enter new computer type: ");
          input(s,2);
          i=atoi(s);
          if ((i>0) && (i<NUM_CTYPES+1)) {
            u.comp_type=i-1;
            if (checkcomp("Ami"))
              u.colors[0]=4;
            else
              u.colors[0]=7;
            write_user(un,&u);
          }
          break;
        case 'S':
          if (u.sl==255)
            break;
          if (u.sl>=thisuser.sl)
            break;
          nl();
          prt(2,"New SL? ");
          input(s,3);
          i=atoi(s);
          if ((!wfc) && (i>=thisuser.sl))
            i=-1;
          if ((i>=0) && (i<255) && (s[0])) {
            u.sl=i;
            write_user(un,&u);
            if (un==usernum)
              realsl=i;
          }
          break;
        case 'T':
          if (u.dsl==255)
            break;
          if (u.dsl>=thisuser.dsl)
            break;
          nl();
          prt(2,"New DSL? ");
          input(s,3);
          i=atoi(s);
          if ((!wfc) && (i>=thisuser.dsl))
            i=-1;
          if ((i>=0) && (i<255) && (s[0])) {
            u.dsl=i;
            write_user(un,&u);
          }
          break;
        case 'E':
          nl();
          prt(2,"New Exemption? ");
          input(s,3);
          i=atoi(s);
          if ((i>=0) && (i<=255) && (s[0])) {
            u.exempt=i;
            write_user(un,&u);
          }
	  break;
	case 'W':
	  nl();
	  prt(2,"ENTER Users NEW Password ");
	  outstr(": ");
	  input(s,8);
	  if (s[0]) {
	  strcpy(u.pw,s);
	  write_user(un,&u);
	  }
	  break;
        case 'Y':
          nl();
          prt(2,"New sysop sub? ");
          input(s,3);
          i=atoi(s);
          if ((i>=0) && (i<=255) && (s[0])) {
            u.sysopsub=i;
            write_user(un,&u);
          }
          break;
        case 'Z':
          nl();
          print( "        ",restrict_string,"");
	  do {
            prt(2,"Toggle? ");
            s[0]=13;
	    s[1]='?';
            strcpy(&(s[2]),restrict_string);
            ch1=onek(s);
            if (ch1==32)
              ch1=13;
	    if (ch1=='?')
	      printmenu(10);
            if ((ch1!=13) && (ch1!='?')) {
              i=-1;
              for (i1=0; i1<16; i1++)
                if (ch1==s[i1+2])
                  i=i1;
              if (i>-1) {
                u.restrict ^= (1 << i);
                write_user(un,&u);
              }
            }
	  } while ((!hangup) && (ch1=='?'));
          break;
        case 'A':
          nl();
          prt(2,"Toggle which AR? ");
          ch1=onek("\rABCDEFGHIJKLMNOP");
          if (ch1!=13) {
            ch1-='A';
            if ((wfc) || (thisuser.ar & (1 << ch1))) {
              u.ar ^= (1 << ch1);
              write_user(un,&u);
            }
          }
          break;
        case 'I':
          nl();
          prt(2,"Toggle which DAR? ");
          ch1=onek("\rABCDEFGHIJKLMNOP");
          if (ch1!=13) {
            ch1-='A';
            if ((wfc) || (thisuser.dar & (1 << ch1))) {
              u.dar ^= (1 << ch1);
              write_user(un,&u);
            }
          }
          break;
        case '~':
          u.ass_pts=0;
          write_user(un,&u);
          break;
	case ':':
	  u.year=0;
	  write_user(un,&u);
	  break;
      }
    } while ((!done1) && (!hangup));
  } while ((!done) && (!hangup));
  close_user();
  if (!wfc)
    topscreen();
}

#pragma warn +par



void prstatus()
{
  char s[81],s1[10];
  int i;
  long l;

  outchr(12);
  print("New User Pass   : ",syscfg.newuserpw,"");
  if (syscfg.closedsystem)
    pl("Board is        : Closed");
  else
    pl("Board is        : Open");
  itoa(status.users,s,10);
  print("Number Users    : ",s,"");
  ltoa(status.callernum1,s,10);
  print("Number Calls    : ",s,"");
  print("Last Date       : ",status.date1,"");
  print("Time            : ",times(),"");
  itoa(status.activetoday,s,10);
  print("Active Today    : ",s,"");
  itoa(status.callstoday,s,10);
  print("Calls Today     : ",s,"");
  itoa(status.msgposttoday,s,10);
  print("M Posted Today  : ",s,"");
  itoa(status.emailtoday,s,10);
  print("E Sent Today    : ",s,"");
  itoa(status.fbacktoday,s,10);
  print("F Sent Today    : ",s,"");
  itoa(status.uptoday,s,10);
  print("Uploads Today   : ",s,"");
  itoa(fwaiting,s,10);
  print("Feedback Waiting: ",s,"");
  i=3;
  l=(long) freek(3);
  while ((l>0) && ((i+'@')<=cdir[0])){
    ltoa(l,s,10);
    s1[1]=0;
    s1[0]='@'+(char) i;
    print(s1,": Free Space   : ",s,"k","");
    l=(long) freek(++i);
  }
  if (sysop2())
    pl("Sysop           : Available");
  else
    pl("Sysop           : NOT Available");
}

void valuser(int un)
{
  userrec u;
  char s[81],s1[81],s2[81],s3[81],ar1[20],dar1[20],ch1;
  int i,i1,ar2,dar2;

  read_user(un,&u);
  if ((u.inact & inact_deleted)==0) {
    nl();
    print("Name: ",nam(&u,un),"");
    print("RN  : ",u.realname,"");
    print("PH  : ",u.phone,"");
    itoa(u.age,s,10);
    s1[0]=32;
    s1[1]=u.sex;
    s1[2]=0;
    print("Age : ",s,s1,"");
    print("Comp: ",&(ctypes[u.comp_type][0]),"");
    if (u.note[0])
      print("Note: ",(u.note),"");
    nl();
    itoa(u.sl,s,10);
    print("SL  : ",s,"");
    if ((u.sl!=255) && (u.sl<thisuser.sl)) {
      outstr("New ? ");
      input(s,3);
      if (s[0]) {
        i=atoi(s);
        if ((!wfc) && (i>=thisuser.sl))
          i=-2;
        if ((i>=0) && (i<255))
          u.sl=i;
	if (i==-1) {
	  nl();
	  prt(5,"Delete? ");
	  if (yn()) {
            deluser(un);
	    nl();
	    pl("Deleted.");
	    nl();
	  } else {
	    nl();
	    pl("NOT deleted.");
	  }
	  return;
	}
      }
    }
    nl();
    itoa(u.dsl,s,10);
    print("DSL : ",s,"");
    if ((u.dsl!=255) && (u.dsl<thisuser.dsl)) {
      outstr("New ? ");
      input(s,3);
      if (s[0]) {
        i=atoi(s);
        if ((!wfc) && (i>=thisuser.dsl))
          i=-1;
        if ((i>=0) && (i<255))
          u.dsl=i;
      }
    }
    strcpy(s3,restrict_string);
    ar2=1;
    dar2=1;
    ar1[0]=13;
    dar1[0]=13;
    for (i=0; i<=15; i++) {
      if (u.ar & (1 << i))
        s[i]='A'+i;
      else
        s[i]=32;
      if (thisuser.ar & (1 << i))
        ar1[ar2++]='A'+i;
      if (u.dar & (1 << i))
        s1[i]='A'+i;
      else
        s1[i]=32;
      if (thisuser.dar & (1 << i))
        dar1[dar2++]='A'+i;
      if (u.restrict & (1 << i))
        s2[i]=s3[i];
      else
        s2[i]=32;
    }
    s[16]=0;
    s1[16]=0;
    s2[16]=0;
    ar1[ar2]=0;
    dar1[dar2]=0;
    nl();
    ch1=0;
    if (ar2>1)
      do {
        print("AR  : ",s,"");
        prt(2,"Togl? ");
        ch1=onek(ar1);
        if (ch1!=13) {
          ch1-='A';
          if (s[ch1]==32)
            s[ch1]=ch1+'A';
          else
            s[ch1]=32;
          u.ar ^= (1 << ch1);
          ch1=0;
        }
      } while ((!hangup) && (ch1!=13));
    nl();
    ch1=0;
    if (dar2>1)
      do {
        print("DAR : ",s1,"");
        prt(2,"Togl? ");
        ch1=onek(dar1);
        if (ch1!=13) {
          ch1-='A';
          if (s1[ch1]==32)
            s1[ch1]=ch1+'A';
          else
            s1[ch1]=32;
          u.dar ^= (1 << ch1);
          ch1=0;
        }
      } while ((!hangup) && (ch1!=13));
    nl();
    ch1=0;
    s[0]=13;
    s[1]='?';
    strcpy(&(s[2]),restrict_string);
    do {
      print("      ",s3,"");
      print("Rstr: ",s2,"");
      prt(2,"Togl? ");
      ch1=onek(s);
      if ((ch1!=13) && (ch1!=32) && (ch1!='?')) {
        i=-1;
        for (i1=0; i1<16; i1++)
          if (ch1==s[i1+2])
            i=i1;
        if (i>-1) {
          u.restrict ^= (1 << i);
          if (s2[i]==32)
            s2[i]=s3[i];
          else
            s2[i]=32;
        }
        ch1=0;
      }
      if (ch1=='?') {
        ch1=0;
        printmenu(10);
      }
    } while ((!hangup) && (ch1==0));
    write_user(un,&u);
    close_user();
    nl();
  } else {
    nl();
    pl("No Such User.");
    nl();
  }
}

void print_quests(int f)
{
  char s[100];
  int i,abort;
  votingrec v;

  abort=0;
  for (i=1; (i<=20) && (abort==0); i++) {
    lseek(f,((long) (i-1)) * sizeof(votingrec), SEEK_SET);
    read(f,(void *)&v,sizeof(votingrec));
    s[0]=32;
    if (i<10)
      itoa(i,&s[1],10);
    else
      itoa(i,&s[0],10);
    strcat(s,": ");
    if (v.numanswers)
      strcat(s,v.question);
    else
      strcat(s,">>> NO QUESTION <<<");
    pla(s,&abort);
  }
  nl();
  if (abort)
    nl();
}


void set_question(int f, int ii)
{
  votingrec v,v1;
  int i,i1,i2;
  char s[81];
  userrec u;
  voting_response vr;

  pl("Enter new question, <C/R> for none.");
  outstr(": ");
  inputl(s,75);
  strcpy(v.question,s);
  v.numanswers=0;
  vr.numresponses=0;
  vr.response[0]='X';
  vr.response[1]=0;
  for (i=0; i<20; i++)
    v.responses[i]=vr;
  while ((v.numanswers<19) && (s[0])) {
    itoa(v.numanswers+1,s,10);
    strcat(s,": ");
    outstr(s);
    inputl(s,63);
    strcpy(vr.response,s);
    vr.numresponses=0;
    v.responses[v.numanswers]=vr;
    if (s[0])
      ++v.numanswers;
  }
  lseek(f,((long) (ii)) * sizeof(votingrec), SEEK_SET);
  write(f,(void *)(&v),sizeof(votingrec));
  lseek(f,((long) (ii)) * sizeof(votingrec), SEEK_SET);
  read(f,(void *)(&v1),sizeof(votingrec));
  close(f);
  if (v.numanswers)
    questused[ii]=1;
  else
    questused[ii]=0;

  read_user(1,&u);
  i1=(int) (filelength(userfile)/sizeof(userrec)) -1;
  for (i=1; i<=i1; i++) {
    read_user(i,&u);
    u.votes[ii]=0;
    write_user(i,&u);
  }
  close_user();
}


void ivotes()
{
  int i,f,abort,n,done;
  char s[81];
  votingrec v;

  close_user();
  strcpy(s,syscfg.datadir);
  strcat(s,"VOTING.DAT");
  f=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
  n=(int) (filelength(f) / sizeof(votingrec)) -1;
  if (n<20) {
    v.question[0]=0;
    v.numanswers=0;
    for (i=n; i<20; i++)
      write(f,(void *)&v,sizeof(votingrec));
  }
  done=0;
  do {
    print_quests(f);
    nl();
    prt(2,"Which (Q=Quit) ? ");
    input(s,2);
    if (strcmp(s,"Q")==0)
      done=1;
    i=atoi(s);
    if ((i>0) && (i<21)) {
      set_question(f,i-1);
      strcpy(s,syscfg.datadir);
      strcat(s,"VOTING.DAT");
      f=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
    }
  } while ((!done) && (!hangup));
  close(f);
}


void chaindata(int n, char *s)
{
  char w,x,y,z,i;
  chainfilerec c;

  c=chains[n];
  if (c.ar==0)
    x=32;
  else {
    for (i=0; i<16; i++)
      if ((1 << i) & c.ar)
        x='A'+i;
  }
  if (c.ansir & ansir_ansi)
    y='Y';
  else
    y='N';
  if (c.ansir & ansir_no_DOS)
    z='N';
  else
    z='Y';
  if (c.ansir & ansir_shrink)
    w='Y';
  else
    w='N';
  sprintf(s,"%2d %-28.28s  %-27.27s %-3d    %1c  %1c  %1c  %1c",
            n,c.description,c.filename,c.sl,y,x,z,w);
}

void showchains()
{
  int abort,i;
  char s[180];

  outchr(12);
  abort=0;
  pla("NN Description                   Path Name                   SL  ANSI AR DOS S",
      &abort);
  pla("== ----------------------------  =========================== --- ==== -- === -",
      &abort);
  for (i=0; (i<numchain) && (!abort); i++) {
    chaindata(i,s);
    pla(s,&abort);
  }
}



void modify_chain(int n)
{
  chainfilerec c;
  char s[81],s1[81],ch,ch2;
  int i,i1,done;

  c=chains[n];
  done=0;
  do {
    outchr(12);
    print("A. Description  : ",c.description,"");
    print("B. Filename     : ",c.filename,"");
    itoa(c.sl,s,10);
    print("C. SL           : ",s,"");
    strcpy(s,"None.");
    if (c.ar!=0) {
      for (i=0; i<16; i++)
        if ((1 << i) & c.ar)
          s[0]='A'+i;
      s[1]=0;
    }
    print("D. AR           : ",s,"");
    if (c.ansir & ansir_ansi)
      pl("E. ANSI         : Required");
    else
      pl("E. ANSI         : Optional");
    if (c.ansir & ansir_no_DOS)
      pl("F. DOS Interrupt: Not used");
    else
      pl("F. DOS Interrupt: Used");
    if (c.ansir & ansir_no_300)
      pl("G. 300 Baud     : Not allowed");
    else
      pl("G. 300 Baud     : Allowed");
    if (c.ansir & ansir_shrink)
      pl("H. Shrink       : Yes");
    else
      pl("H. Shrink       : No");
    nl();
    prt(2,"Which (A-G,Q) ? ");
    ch=onek("QABCDEFGH");
    switch(ch) {
      case 'Q':done=1; break;
      case 'A':
        nl();
        prt(2,"New Description? ");
        inputl(s,40);
        if (s[0])
          strcpy(c.description,s);
        break;
      case 'B':
        nl();
        prt(2,"New Filename? ");
        input(s,40);
        if (s[0]!=0)
          strcpy(c.filename,s);
        break;
      case 'C':
        nl();
        prt(2,"New SL? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<256) && (s[0]))
          c.sl=i;
        break;
      case 'D':
        nl();
        prt(2,"New AR (<SPC>=None) ? ");
        ch2=onek("ABCDEFGHIJKLMNOP ");
        if (ch2==32)
          c.ar=0;
        else
          c.ar=1 << (ch2-'A');
        break;
      case 'E':
        nl();
        prt(5,"Require ANSI? ");
        if (yn())
	  c.ansir |= ansir_ansi;
	else
	  c.ansir &= ~ansir_ansi;
        break;
      case 'F':
        nl();
        prt(5,"Have BBS intercept DOS calls? ");
        if (ny())
	  c.ansir &= ~ansir_no_DOS;
	else
	  c.ansir |= ansir_no_DOS;
        break;
      case 'G':
        nl();
        prt(5,"Allow 300 baud users to run? ");
        if (ny())
	  c.ansir &= ~ansir_no_300;
	else
	  c.ansir |= ansir_no_300;
        break;
      case 'H':
        nl();
        prt(5,"Shrink the BBS to run? ");
        if (yn())
          c.ansir |= ansir_shrink;
        else
          c.ansir &= ~ansir_shrink;
        break;
    }
  } while ((!done) && (!hangup));
  chains[n]=c;
}


void insert_chain(int n)
{
  chainfilerec c;
  int i,i1,nu;

  for (i=numchain-1; i>=n; i--)
    chains[i+1]=chains[i];
  strcpy(c.description,"** NEW CHAIN **");
  strcpy(c.filename,"REM");
  c.sl=10;
  c.ar=0;
  c.ansir=0;
  chains[n]=c;
  ++numchain;
  modify_chain(n);
}


void delete_chain(int n)
{
  int i,i1,nu;

  for (i=n; i<numchain; i++)
    chains[i]=chains[i+1];
  --numchain;
}


void chainedit()
{
  int i,i1,i2,done,f;
  char s[81],s1[81],s2[81],ch;

  if (!checkpw())
    return;
  showchains();
  done=0;
  do {
    nl();
    prt(2,"Chains: D:elete, I:nsert, M:odify, Q:uit, ? : ");
    ch=onek("QDIM?");
    switch(ch) {
      case '?':
        showchains();
        break;
      case 'Q':
        done=1;
        break;
      case 'M':
        nl();
        prt(2,"Chain number? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<numchain))
          modify_chain(i);
        break;
      case 'I':
        if (numchain<50) {
          nl();
          prt(2,"Insert before which chain? ");
          input(s,2);
          i=atoi(s);
          if ((s[0]!=0) && (i>=0) && (i<=numchain))
            insert_chain(i);
        }
        break;
      case 'D':
        nl();
        prt(2,"Delete which chain? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<numchain)) {
          nl();
          sprintf(s1,"Delete %s? ",chains[i].description);
          prt(5,s1);
          if (yn())
            delete_chain(i);
        }
        break;
    }
  } while ((!done) && (!hangup));
  strcpy(s,syscfg.datadir);
  strcat(s,"CHAINS.DAT");
  f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(f,(void *)chains, numchain * sizeof(chainfilerec));
  close(f);
}

