/*****************************************************************************

				WWIV Version 4
		      Copyright (C) 1988 by Wayne Bell

Distribution of the source code for WWIV, in any form, modified or unmodified,
without PRIOR, WRITTEN APPROVAL by the author, is expressly prohibited.
Distribution of compiled versions of WWIV is limited to copies compiled BY
THE AUTHOR.  Distribution of any copies of WWIV not compiled by the author
is expressly prohibited.


*****************************************************************************/



#include <stdio.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <time.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <io.h>
#include <alloc.h>
#include "vardec.h"
#include "fcns.h"

extern userrec thisuser;
extern directoryrec directories[64];
extern int num_dirs,hangup,userfile,echo,useron,userfile,usernum;
extern int incom,fwaiting,helpl;
extern configrec syscfg;
extern statusrec status;
extern char ctypes[NUM_CTYPES][18];
extern int edlf,dlf,curdir,numf;
extern usersubrec udir[64];
extern long nscandate;
extern char curspeed[81],cdir[81];
extern unsigned int modem_speed,com_speed;
extern float batchtime,batchfntime[50];
extern int numbatch, batchdir[50],num_listed;
extern char batchfn[50][13];
extern double extratimecall;
extern unsigned char realsl;

#define SETREC(i)  lseek(dlf,((long) (i))*((long)sizeof(uploadsrec)),SEEK_SET);


/* How far to indent extended descriptions */
#define INDENTION 21

/* Max # of lines for extended description */
#define MAX_LINES 10

/* If its OK to use the FSED for editing extended descriptions */
#define FSED_OK ((okfsed()) && (0))

/* If this is defined, the system will put in "ASK" if a file isn't there */
#define CHECK_FOR_EXISTANCE

/* the archive type to use */
#define ARC_NUMBER 0

int okfn(char *s)
{
  int i,l,ok;
  unsigned char ch;

  ok=1;
  l=strlen(s);
  for (i=0; i<l; i++) {
    ch=s[i];
    if ((ch==' ') || (ch=='/') || (ch=='\\') || (ch==':') ||
        (ch=='>') || (ch=='<') || (ch=='|')  || (ch=='+') ||
        (ch==',') || (ch==';') || (ch>126))
      ok=0;
  }
  return(ok);
}



void get_arc_cmd(char *out, char *arcfn, int cmd, char *ofn)
{
  char *ss,*ss1,s[161];
  int i;

  out[0]=0;
  ss=strchr(arcfn,'.');
  if (ss==NULL)
    return;
  ++ss;
  ss1=strchr(ss,'.');
  while (ss1!=NULL) {
    ss=ss1;
    ++ss1;
    ss1=strchr(ss,'.');
  }
  for (i=0; i<4; i++)
    if (stricmp(ss,syscfg.arcs[i].extension)==0) {
      switch(cmd) {
        case 0: strcpy(s,syscfg.arcs[i].arcl); break;
        case 1: strcpy(s,syscfg.arcs[i].arce); break;
        case 2: strcpy(s,syscfg.arcs[i].arca); break;
      }
      if (s[0]==0)
        return;
      stuff_in(out,s,arcfn,ofn,"","","");
      return;
    }
}


int list_arc_out(char *fn, char *dir)
{
  char s[161],s1[81];
  int i=0;


  strcpy(s1,dir);
  strcat(s1,fn);
  get_arc_cmd(s,s1,0,"");
  if (!okfn(fn))
    s[0]=0;
  if (exist(s1) && (s[0]!=0)) {
    nl();
    nl();
    print("Archive listing for ",fn,":","");
    nl();
    i=do_external(s,1);
    nl();
  } else {
    nl();
    outs("Unknown archive: ");
    pl(fn);
    nl();
    i=0;
  }
  return(i);
}


void list_temp_arc()
{
  char s1[81],s2[81];

  strcpy(s1,"TEMP.");
  strcat(s1,syscfg.arcs[ARC_NUMBER].extension);
  list_arc_out(s1,syscfg.tempdir);
  nl();
}

void download_temp_arc()
{
  char s[81],s1[81];
  long numbytes;
  double d;
  int i,f,sent,abort;

  if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio) &&
    ((thisuser.exempt & exempt_ratio)==0)) {
    nl();
    nl();
    sprintf(s,"Your ratio is %-5.3f.  You need a ratio of %-5.3f to download.",
      ratio(), syscfg.req_ratio);
    pl(s);
    nl();
    return;
  }
  sprintf(s1,"%sTEMP.%s",syscfg.tempdir,syscfg.arcs[ARC_NUMBER].extension);
  f=open(s1,O_RDWR | O_BINARY);
  if (f<0) {
    nl();
    nl();
    pl("There is no temporary archive file.");
    nl();
    return;
  }
  numbytes=filelength(f);
  close(f);
  if (numbytes==0L) {
    nl();
    nl();
    pl("There is no temporary archive file.");
    nl();
    return;
  }
  d=((double) (((numbytes)+127)/128)) *
    (1420.4) /
    ((double) (modem_speed));
  if (d<=nsl()) {
    print("Approx. time: ",ctim(d),"");
    sent=0;
    abort=0;
    strcpy(s,"TEMP.");
    strcat(s,syscfg.arcs[ARC_NUMBER].extension);
    send_file(s1,&sent,&abort,0,s,-1,numbytes);
    if (sent) {
      ++thisuser.downloaded;
      thisuser.dk += ((numbytes+1023)/1024);
      sprintf(s1,"Downloaded %ldk of temporary file",(numbytes+1023)/1024);
      sysoplog(s1);
      nl();
      nl();
      sprintf(s1,"%-6.3f",ratio());
      print("Your ratio is now: ",s1,"");
      if (useron)
        topscreen();
    }
  } else {
    nl();
    nl();
    pl("Not enough time left to D/L.");
    nl();
  }
}

void add_temp_arc()
{
  char s[81],s1[81],s2[81],s3[81];
  int i;

  nl();
  pl("Enter filename to add to temporary");
  pl("archive file.  May contain wildcards.");
  prt(2,": ");
  input(s,12);
  if (!okfn(s))
    return;
  if (s[0]==0)
    return;
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  strcpy(s2,stripfn(s));
  for (i=0; i<strlen(s2); i++)
    if ((s2[i]=='|') || (s2[i]=='>') || (s2[i]=='<') || (s2[i]==';') || (s2[i]==' ') ||
        (s2[i]==':') || (s2[i]=='/') || (s2[i]=='\\'))
      return;
  sprintf(s1,"%sTEMP.%s",syscfg.tempdir,syscfg.arcs[ARC_NUMBER].extension);
  strcpy(s3,syscfg.tempdir);
  strcat(s3,s2);
  get_arc_cmd(s,s1,2,s3);
  if (s[0]) {
    strcpy(s1,"Added '");
    strcat(s1,s2);
    strcat(s1,"' to temporary archive");
    sysoplog(s1);
    do_external(s,0);
  } else
    pl("Sorry, can't add to temp archive.");
}

void del_temp()
{
  char s[81],s1[81];
  nl();
  prt(2,"Filename to delete: ");
  input(s1,12);
  if (!okfn(s1))
    return;
  if (s1[0]) {
    if (strchr(s1,'.')==NULL)
      strcat(s1,".*");
    remove_from_temp(s1,1);
  }
}

void list_temp_dir()
{
  int i,i1,f1,ok;
  char s[81],s1[81];
  struct ffblk ff;
  uploadsrec u;

  strcpy(s1,syscfg.tempdir);
  strcpy(s,"*.*");
  strcat(s1,s);
  f1=findfirst(s1,&ff,0);
  ok=1;
  nl();
  pl("Files in temporary directory:");
  nl();
  i1=0;
  while ((f1==0) && (!hangup) && (ok)) {
    strcpy(s,(ff.ff_name));
    align(s);
    sprintf(s1,"%12s  %-8ld",s,ff.ff_fsize);
    pl(s1);
    f1=findnext(&ff);
    i1=1;
  }
  if (!i1)
    pl("None.");
  nl();
  if ((ok) && (!hangup)) {
    sprintf(s,"Free space: %ldk.",(long) freek1(syscfg.tempdir));
    pl(s);
    nl();
  }
}


void temp_extract()
{
  int i,i1,i2,i3,ok,abort,ok1;
  char s[81],s1[81],s2[81],s3[81];
  uploadsrec u,u1;

  dliscan();
  nl();
  pl("Extract to temporary directory:");
  nl();
  prt(2,"Filename: ");
  input(s,12);
  if (!okfn(s))
    return;
  if (s[0]==0)
    return;
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  align(s);
  i=recno(s);
  ok=1;
  while ((i>0) && (ok) && (!hangup)) {
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    strcpy(s2,(directories[udir[curdir].subnum].path));
    strcat(s2,u.filename);
    get_arc_cmd(s1,s2,1,"");
    if ((s1[0]) && (exist(s2))) {
      nl();
      nl();
      abort=0;
      printinfo(&u,&abort);
      nl();
      do {
        prt(2,"Extract what (?=list,Q=abort) ? ");
        input(s1,12);
        if (s1[0]==0)
          ok1=0;
        else
          ok1=1;
        if (!okfn(s1))
          ok1=0;
        if (strcmp(s1,"?")==0) {
          list_arc_out(stripfn(u.filename),directories[udir[curdir].subnum].path);
          s1[0]=0;
        }
        if (strcmp(s1,"Q")==0) {
          ok=0;
          s1[0]=0;
        }
        i2=0;
        for (i1=0; i1<strlen(s1); i1++)
          if ((s1[i1]=='|') || (s1[i1]=='>') || (s1[i1]=='<') || (s1[i1]==';') || (s1[i1]==' '))
	    i2=1;
        if (i2)
          s1[0]=0;
        if (s1[0]) {
          if (strchr(s1,'.')==NULL)
            strcat(s1,".*");
          cd_to(directories[udir[curdir].subnum].path);
          get_dir(s2,1);
          strcat(s2,stripfn(u.filename));
          cd_to(cdir);
          cd_to(syscfg.tempdir);
          get_arc_cmd(s3,s2,1,stripfn(s1));
          if (!okfn(s1))
            s3[0]=0;
          if (s3[0]) {
            do_external(s3,0);
            sprintf(s2,"Extracted out %s from %s",s1,u.filename);
          } else
            s2[0]=0;
          cd_to(cdir);
          if (s2[0])
            sysoplog(s2);
        }
      } while ((!hangup) && (ok) && (ok1));
    } else
      if (s1[0]) {
        nl();
        pl("That file currently isn't there.");
        nl();
      }
    if (ok)
      i=nrecno(s,i);
  }
  closedl();
}

void list_temp_text()
{
  int i,i1,f1,ok,sent;
  char s[81],s1[81];
  struct ffblk ff;
  uploadsrec u;
  double percent;

  nl();
  prt(2,"List what file(s) ? ");
  input(s,12);
  if (!okfn(s))
    return;
  if (s[0]) {
    if (strchr(s,'.')==NULL)
      strcat(s,".*");
    strcpy(s1,syscfg.tempdir);
    strcat(s1,stripfn(s));
    f1=findfirst(s1,&ff,0);
    ok=1;
    nl();
    while ((f1==0) && (ok)) {
      strcpy(s,syscfg.tempdir);
      strcat(s,(ff.ff_name));
      nl();
      print("Listing ",ff.ff_name,"");
      nl();
      ascii_send(s,&sent,&percent);
      if (sent) {
        sprintf(s,"Temp text D/L '%s'",ff.ff_name);
        sysoplog(s);
      } else {
        sprintf(s,"Temp Tried text D/L '%s' %3.2f%%",ff.ff_name,percent*100.0);
        sysoplog(s);
        ok=0;
      }
      f1=findnext(&ff);
    }
  }
}


void temporary_stuff()
{
  char s[81],s1[81],ch;
  int done;

  done=0;
  do {
    nl();
    prt(2,"Archive: Q,D,R,A,V,L,T: ");
    ch=onek("Q?DRAVLT");
    switch(ch) {
      case 'Q':
	done=1;
	break;
      case 'D':
	download_temp_arc();
	break;
      case 'V':
	list_temp_arc();
	break;
      case 'A':
        add_temp_arc();
	break;
      case 'R':
	del_temp();
	break;
      case 'L':
	list_temp_dir();
	break;
      case 'T':
	list_temp_text();
	break;
      case '?':
	printmenu(14);
	break;
    }
  } while ((!hangup) && (!done));
}



int dcs()
{
  if (cs())
    return(1);
  if (thisuser.dsl>=100)
    return(1);
  else
    return(0);
}


void dliscan1(int dn)
{
  char s[81];
  int i;
  uploadsrec u;

  sprintf(s,"%s%s.DIR",syscfg.datadir,directories[dn].filename);
  dlf=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
  i=filelength(dlf)/sizeof(uploadsrec);
  if (i==0) {
    u.numbytes=0;
    SETREC(0);
    write(dlf,(void *)&u,sizeof(uploadsrec));
  } else {
    SETREC(0);
    read(dlf,(void *)&u,sizeof(uploadsrec));
  }
  numf=u.numbytes;

  sprintf(s,"%s%s.EXT",syscfg.datadir,directories[dn].filename);
  edlf=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
}


void dliscan()
{
  dliscan1(udir[curdir].subnum);
}


void closedl()
{
  if (dlf>0) {
    close(dlf);
    dlf=-1;
  }
  if (edlf>0) {
    close(edlf);
    edlf=-1;
  }
}

void add_extended_description(char *fn, char *desc)
{
  ext_desc_type ed;

  strcpy(ed.name,fn);
  ed.len=strlen(desc);
  lseek(edlf,0L,SEEK_END);
  write(edlf,&ed,sizeof(ext_desc_type));
  write(edlf,desc,ed.len);
}


void delete_extended_description(char *fn)
{
  ext_desc_type ed;
  long r,w,l1;
  char *ss=NULL;

  r=w=0;
  if ((ss=malloca(10240L))==NULL)
    return;
  l1=filelength(edlf);
  while (r<l1) {
    lseek(edlf,r,SEEK_SET);
    read(edlf,&ed,sizeof(ext_desc_type));
    read(edlf,ss,ed.len);
    if (strcmp(fn,ed.name)) {
      if (r!=w) {
        lseek(edlf,w,SEEK_SET);
        write(edlf,&ed,sizeof(ext_desc_type));
        write(edlf,ss,ed.len);
      }
      w +=(sizeof(ext_desc_type) + ed.len);
    }
    r += (sizeof(ext_desc_type) + ed.len);
  }
  chsize(edlf,w);
}


char *read_extended_description(char *fn)
{
  ext_desc_type ed;
  long l,l1;
  char *ss=NULL;

  l=0;
  l1=filelength(edlf);
  while (l<l1) {
    lseek(edlf,l,SEEK_SET);
    l += (long) read(edlf,&ed,sizeof(ext_desc_type));
    if (strcmp(fn,ed.name)==0) {
      ss=malloca((long) ed.len+10);
      if (ss) {
        read(edlf,ss,ed.len);
        ss[ed.len]=0;
      }
      return(ss);
    } else
      l += (long) ed.len;
  }
  return(NULL);
}



void print_extended(char *fn, int *abort, unsigned char numlist, int indent)
{
  char *ss;
  int next=0;
  unsigned char numl=0;
  int cpos=0;
  char ch,s[81];
  int i;

  ss=read_extended_description(fn);
  if (ss) {
    ch=10;
    while ((ss[cpos]) && (!(*abort)) && (numl<numlist)) {
      if ((ch==10) && (indent)) {
        if (okansi())
          sprintf(s,"\x1b[%dC",INDENTION);
        else {
          for (i=0; i<INDENTION; i++)
            s[i]=32;
          s[INDENTION]=0;
        }
        osan(s,abort,&next);
        if ((thisuser.sysstatus & sysstatus_funky_colors) && (!(*abort)))
          ansic(5);
      }
      outchr(ch=ss[cpos++]);
      checka(abort,&next);
      if (ch==10)
        ++numl;
      else
        if ((ch!=13) && (wherex()>=78)) {
          osan("\r\n",abort,&next);
          ch=10;
        }
    }
    if (wherex())
      nl();
  }
  farfree(ss);
}



void modify_extended_description(char **sss)
{
  char s[161],s1[161];
  int f,ii,i,i1,i2;

  if (*sss)
    ii=1;
  else
    ii=0;
   do {
    if (ii) {
      nl();
      if (FSED_OK)
	prt(5,"Modify the extended description? ");
      else
        prt(5,"Enter a new extended description? ");
      if (!yn())
	return; }
      else {
      if(!so())
	return;
      nl();
      prt(5,"Enter an extended description? ");
      if (!yn())
      return;
      }
    if (FSED_OK) {
      strcpy(s,syscfg.tempdir);
      strcat(s,"extended.dsc");
      if (*sss) {
        f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
        write(f,*sss,strlen(*sss));
        close(f);
        farfree(*sss);
        *sss=NULL;
      } else
        unlink(s);
      i=thisuser.screenchars;
      if (thisuser.screenchars>(76-INDENTION))
        thisuser.screenchars=76-INDENTION;
      i1=external_edit("extended.dsc",syscfg.tempdir,(int) thisuser.defed-1,MAX_LINES);
      thisuser.screenchars=i;
      if (i1) {
        if ((*sss=malloca(10240))==NULL)
          return;
        f=open(s,O_RDWR | O_BINARY);
        read(f,*sss,(int) filelength(f));
        close(f);
      }
    } else {
      if (*sss)
        farfree(*sss);
      if ((*sss=malloca(10240))==NULL)
        return;
      *sss[0]=0;
      i=1;
      nl();
      sprintf(s,"Enter up to %d lines, %d chars each.",MAX_LINES,78-INDENTION);
      pl(s);
      nl();
      s[0]=0;
      i1=thisuser.screenchars;
      if (thisuser.screenchars>(76-INDENTION))
        thisuser.screenchars=76-INDENTION;
      do {
        itoa(i,s1,10);
        strcat(s1,": ");
        prt(2,s1);
        s1[0]=0;
        inli(s1,s,90,1);
        i2=strlen(s1);
        if (i2 && (s1[i2-1]==1))
          s1[i2-1]=0;
        if (s1[0]) {
          strcat(s1,"\r\n");
          strcat(*sss,s1);
        }
      } while ((i++<10) && (s1[0]));
      thisuser.screenchars=i1;
      if (*sss[0]==0) {
        farfree(*sss);
        *sss=NULL;
      }
    }
    prt(5,"Is this what you want? ");
    i=!yn();
  } while (i);
}


void align(char *s)
{
  char f[40],e[40],s1[20],*s2;
  int i,i1,i2;

  i1=0;
  if (s[0]=='.')
    i1=1;
  for (i=0; i<strlen(s); i++)
    if ((s[i]=='\\') || (s[i]=='/') || (s[i]==':') || (s[i]=='<') ||
      (s[i]=='>') || (s[i]=='|'))
      i1=1;
  if (i1) {
    strcpy(s,"        .   ");
    return;
  }
  s2=strchr(s,'.');
  if (s2==NULL) {
    e[0]=0;
  } else {
    strcpy(e,&(s2[1]));
    e[3]=0;
    s2[0]=0;
  }
  strcpy(f,s);

  for (i=strlen(f); i<8; i++)
    f[i]=32;
  f[8]=0;
  i1=0;
  i2=0;
  for (i=0; i<8; i++) {
    if (f[i]=='*')
      i1=1;
    if (f[i]==' ')
      i2=1;
    if (i2)
      f[i]=' ';
    if (i1)
      f[i]='?';
  }

  for (i=strlen(e); i<3; i++)
    e[i]=32;
  e[3]=0;
  i1=0;
  for (i=0; i<3; i++) {
    if (e[i]=='*')
      i1=1;
    if (i1)
      e[i]='?';
  }

  for (i=0; i<12; i++)
    s1[i]=32;
  strcpy(s1,f);
  s1[8]='.';
  strcpy(&(s1[9]),e);
  strcpy(s,s1);
}


int compare(char *s1, char *s2)
{
  int ok,i;

  ok=1;
  for (i=0; i<12; i++)
    if ((s1[i]!=s2[i]) && (s1[i]!='?') && (s2[i]!='?'))
      ok=0;
  return(ok);
}


void printinfo(uploadsrec *u, int *abort)
{
  char s[85],s1[40],s2[81];
  int i,next,fc;

  fc=thisuser.sysstatus & sysstatus_funky_colors;

  if (fc)
    ansic(1);
  strncpy(s,u->filename,8);
  s[8]=0;
  osan(s,abort,&next);
  strncpy(s,&((u->filename)[8]),4);
  s[4]=0;
  if (fc)
    ansic(2);
  osan(s,abort,&next);
  if (fc)
    ansic(0);
  osan(": ",abort,&next);

  ltoa((((u->numbytes)+1023)/1024),s1,10);
  strcat(s1,"k");

#ifdef CHECK_FOR_EXISTANCE
  strcpy(s2,directories[udir[curdir].subnum].path);
  strcat(s2,u->filename);
  if (!(okansi())) {
    if (!exist(s2))
      strcpy(s1,"ASK");
    }
#endif

  for (i=0; i<5-strlen(s1); i++)
    s[i]=32;
  s[i]=0;
  strcat(s,s1);
  if (fc)
    ansic(3);
  if (!exist(s2))
    ansic(6);
  osan(s,abort,&next);

  if (fc || (!exist(s2)))
    ansic(0);
  osan(" :",abort,&next);
  if (fc)
    ansic(5);
  pla(u->description,abort);
  if ((!*abort) && (thisuser.num_extended) && (u->mask & mask_extended))
    print_extended(u->filename,abort,thisuser.num_extended,1);
  if (!(*abort))
    ++num_listed;
}


void printtitle(int *abort)
{
  char s[81],s1[20];
  int i,i1;

  pla("",abort);
  pla("",abort);
  sprintf(s,"%s - #%s, %d files.",directories[udir[curdir].subnum].name,
                                  udir[curdir].keys,numf);
  i=strlen(s);
  if (thisuser.sysstatus & sysstatus_funky_colors)
    ansic(2);
  pla(s,abort);
  for (i1=0; i1<i; i1++)
    s[i1]='=';
  s[i]=0;
  if (thisuser.sysstatus & sysstatus_funky_colors)
    ansic(2);
  pla(s,abort);
  pla("",abort);
}


void file_mask(char *s)
{
  nl();
  helpl=9;
  prt(2,"File mask: ");
  input(s,12);
  if (s[0]==0)
    strcpy(s,"*.*");
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  align(s);
  nl();
}


void listfiles()
{
  char s[81];
  int i,abort;
  uploadsrec u;

  dliscan();
  file_mask(s);
  abort=0;
  num_listed=0;
  printtitle(&abort);
  for (i=1; (i<=numf) && (!abort) && (!hangup); i++) {
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    if (compare(s,u.filename))
      printinfo(&u,&abort);
  }
  closedl();
  if (!abort) {
    nl();
    nl();
    sprintf(s,"Files listed: %d",num_listed);
    pl(s);
    nl();
  }
}


void nscandir(int d, int *abort,int title)
{
  int i,od,dt;
  uploadsrec u;
  char s[81];

  od=curdir;
  curdir=d;
  dt=title;
  dliscan();
  for (i=1; (i<=numf) && (!(*abort)) && (!hangup); i++) {
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    if (u.daten>=nscandate) {
      if (dt) {
        printtitle(abort);
        dt=0;
      }
      printinfo(&u,abort);
    }
  }
  closedl();
  curdir=od;
}


void nscanall()
{
  int abort,i,i1;
  char s[81];
  struct date d;
  struct time t;


  abort=0;
  num_listed=0;
  nl();                             /* New Scan Notification Mod */
  unixtodos(nscandate,&d,&t);
  prt(3,"Now scanning for files that have been uploaded since ");
  sprintf(s,"%02d/%02d/%02d",d.da_mon,d.da_day,(d.da_year-1900));
  prt(2,s);;
  nl();
  for (i=0; (i<64) && (!abort) && (udir[i].subnum!=-1); i++) {
    i1=udir[i].subnum;
    if (i1>=32) {
      if (thisuser.nscn2 & (1L << (i1-32)))
        nscandir(i,&abort,1);
    } else {
      if (thisuser.nscn1 & (1L << i1))
        nscandir(i,&abort,1);
    }
  }
  if ((num_listed) && (!abort)) {
    nl();
    nl();
    sprintf(s,"Files listed: %d",num_listed);
    pl(s);
    nl();
  }
}


void searchall()
{
  int i,i1,pts,abort,pty,ocd;
  char s[81],s1[81];
  uploadsrec u;

  abort=0;
  ocd=curdir;
  nl();
  nl();
  pl("Search all directories.");
  file_mask(s);
  num_listed=0;
  for (i=0; (i<64) && (!abort) && (!hangup) && (udir[i].subnum!=-1); i++) {
    i1=udir[i].subnum;
    pts=0;
    if (i1>=32) {
      if (thisuser.nscn2 & (1L << (i1-32)))
        pts=1;
    } else {
      if (thisuser.nscn1 & (1L << i1))
        pts=1;
    }
    pts=1;
    /* remove pts=1 to search only marked directories */
    if (pts) {
      curdir=i;
      dliscan();
      pty=1;
      for (i1=1; (i1<=numf) && (!abort) && (!hangup); i1++) {
        SETREC(i1);
        read(dlf,(void *)&u,sizeof(uploadsrec));
        if (compare(s,u.filename)) {
          if (pty) {
            printtitle(&abort);
            pty=0;
          }
          printinfo(&u,&abort);
        }
      }
      closedl();
    }
  }
  curdir=ocd;
  if ((num_listed) && (!abort)) {
    nl();
    nl();
    sprintf(s,"Files listed: %d",num_listed);
    pl(s);
    nl();
  }
}



int recno(char *s)
{
  int i;
  uploadsrec u;

  i=1;
  if (numf<1)
    return(-1);
  SETREC(i);
  read(dlf,(void *)&u,sizeof(uploadsrec));
  while ((i<numf) && (compare(s,u.filename)==0)) {
    ++i;
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
  }
  if (compare(s,u.filename))
    return(i);
  else
    return(-1);
}


int nrecno(char *s,int i1)
{
  int i;
  uploadsrec u;

  i=i1+1;
  if ((numf<1) || (i1>=numf))
    return(-1);

  SETREC(i);
  read(dlf,(void *)&u,sizeof(uploadsrec));
  while ((i<numf) && (compare(s,u.filename)==0)) {
    ++i;
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
  }
  if (compare(s,u.filename))
    return(i);
  else
    return(-1);
}


int printfileinfo(uploadsrec *u, int dn)
{
  char s[81];
  double d;
  int i,abort;

  d=((double) (((u->numbytes)+127)/128)) *
    (1420.4) /
    ((double) (modem_speed));
  print("Filename   : ",stripfn(u->filename),"");
  print("Description: ",(u->description),"");
  ltoa(((u->numbytes)+1023)/1024,s,10);
  print("File size  : ",s,"k","");
  print("Apprx. time: ",ctim(d),"");
  print("Uploaded on: ",(u->date),"");
  print("Uploaded by: ",(u->upby),"");
  itoa((u->numdloads),s,10);
  print("Times D/L'd: ",s,"");
  nl();
  abort=0;
  if (u->mask & mask_extended) {
    pl("Extended Description: ");
    print_extended(u->filename,&abort,255,0);
  }

  sprintf(s,"%s%s",directories[dn].path,u->filename);
  if (!exist(s)) {
    nl();
    pl("->FILE NOT THERE<-");
    nl();
  }

  if (nsl()>=d)
    return(1);
  else
    return(0);
}


void upload(int dn)
{
  directoryrec d;
  uploadsrec u,u1;
  int i,i1,i2,ok,xfer,f;
  char s[81],s1[81],*ss;
  long l;
  double ti;

  dliscan1(dn);
  d=directories[dn];
  if (numf>=d.maxfiles) {
    nl();
    nl();
    pl("This directory is currently full.");
    nl();
    closedl();
    return;
  }
  if (d.mask & mask_no_uploads) {
    nl();
    nl();
    pl("Uploads are not allowed to this directory.");
    nl();
    closedl();
    return;
  }
  nl();
  l=(long)freek1(d.path);
  sprintf(s,"Upload - %ldk free.",l);
  pl(s);
  nl();
  if (l<100) {
    pl("Not enough disk space to upload here.");
    nl();
    closedl();
    return;
  }
  prt(2,"Filename: ");
  input(s,12);
  if (!okfn(s))
    s[0]=0;
  align(s);
  strcpy(u.filename,s);
  u.ownerusr=usernum;
  u.ownersys=0;
  u.numdloads=0;
  u.filetype=0;
  u.mask=0;
  strcpy(u.upby,nam1(&thisuser,usernum,syscfg.systemnumber));
  strcpy(u.date,date());
  nl();
  ok=1;
  xfer=1;
  if ((strstr(s,".ARC")) || (strstr(s,".PAK")) || (strstr(s,".LZH"))
   || (strstr(s,".ZOO")) || (strstr(s,".ICE")) || (strstr(s,".TXT"))
   || (strstr(s,".DOC"))) {
    prt(6,"Upload files compressed with PkZip only!");
    nl();
    ok=0;
    xfer=0;
    add_ass(5,s);
    strcpy(s1,"You just earned yourself five demerits!");
    }
  if (ok)
  sprintf(s1,"Upload '%s' to %s? ",s,d.name);
  if (strcmp(s,"        .   "))
    prt(5,s1);
  else
    ok=0;
  if ((ok) && (yn())) {
    strcpy(s1,d.path);
    strcat(s1,s);
    if (exist(s1)) {
      if (dcs()) {
        xfer=0;
        nl();
        nl();
        pl("File already exists.");
        prt(5,"Add to database anyway? ");
        if (yn()==0)
          ok=0;
      } else {
        nl();
        nl();
        pl("That file is already here.");
        nl();
        ok=0;
      }
    } else
      if (!incom) {
        nl();
        pl("File isn't already there.");
        pl("Can't upload locally.");
        nl();
        ok=0;
      }
    if ((d.mask & mask_PD) && (ok)) {
      nl();
      prt(5,"Is this program PD/Shareware? ");
      if (!yn()) {
        nl();
        pl("This directory is for Public Domain/");
        pl("Shareware programs ONLY.  Please do not");
        pl("upload other problems.  If you have");
        pl("trouble with this policy, please contact");
        pl("the sysop.");
        nl();
        sprintf(s,"Wanted to upload '%s'",u.filename);
	add_ass(5,s);
	ok=0;
      } else
        u.mask=mask_PD;
    }
    if (ok) {
      nl();
      pl("Please enter a one line description.");
      outstr(": ");
      inputl(u.description,58);
      nl();
      if (xfer) {
        ti=timer();
        receive_file(s1,&ok,&u.filetype);
        ti=timer()-ti;
        if (ti<0)
          ti += 24.0*3600.0;
        thisuser.extratime += ti;
      }
      if (ok) {
        f=open(s1,O_RDONLY | O_BINARY);
        if (f<0) {
          ok=0;
          nl();
          nl();
          pl("DOS error - File not found.");
          nl();
        }
        if (ok) {
          l=filelength(f);
          u.numbytes=l;
          close(f);
          ++thisuser.uploaded;
          thisuser.uk += ((l+1023)/1024);
          time(&l);
          u.daten=l;
          ss=NULL;
          modify_extended_description(&ss);
          if (ss) {
            add_extended_description(u.filename,ss);
            u.mask |= mask_extended;
            farfree(ss);
          }
          for (i=numf; i>=1; i--) {
            SETREC(i);
            read(dlf,(void *)&u1,sizeof(uploadsrec));
            SETREC(i+1);
            write(dlf,(void *)&u1,sizeof(uploadsrec));
          }
          SETREC(1);
          write(dlf,(void *)&u,sizeof(uploadsrec));
          ++numf;
          u1.numbytes=numf;
          SETREC(0);
          write(dlf,(void *)&u1,sizeof(uploadsrec));
          ++status.uptoday;
          save_status();
          sprintf(s,"+%s uploaded on %s",u.filename,directories[dn].name);
	  sysoplog(s);
	  nl();
          nl();
          pl("File uploaded.");
	  nl();
	  if(strstr(s1,".ZIP")){     /* ZIP Comment Mod */
	  strcpy(s,"pkzip -z ");
	  strcat(s,(directories[udir[curdir].subnum].path));
	  strcat(s,(stripfn(u.filename)));
	  strcat(s," <c:\\txt\\comment.asc>nul:");
	  run_external(s);}
          sprintf(s,"%-6.3f",ratio());
          print("Your ratio is now: ",s,"");
          nl();
	  nl();
          if (useron)
            topscreen();
        }
      } else {
        nl();
        nl();
        pl("File transmission aborted.");
        nl();
      }
    }
  }
  closedl();
}


/****************************************************************************/
int try_to_download(char *s, int dn,int title)
{
  int i,ok,sent,abort;
  uploadsrec u;
  char s1[81];

  dliscan1(dn);
  i=recno(s);
  if (i<=0) {
    closedl();
    return(0);
  }
  ok=1;
  while ((i>0) && (ok) && (!hangup)) {
    if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio) &&
      ((thisuser.exempt & exempt_ratio)==0)) {
      nl();
      nl();
      sprintf(s,"Your ratio is %-5.3f.  You need a ratio of %-5.3f to download.",
        ratio(), syscfg.req_ratio);
      pl(s);
      nl();
      closedl();
      return(-1);
    }
    tleft(1);
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    nl();
    if (title)
      print("Directory  : ",directories[dn].name,"");
    if ((printfileinfo(&u,dn)) || (strncmp(u.filename,"WWIV4",5)==0)) {
      strcpy(s1,(directories[dn].path));
      strcat(s1,u.filename);
      sent=0;
      abort=0;
      send_file(s1,&sent,&abort,u.filetype,u.filename,dn, u.numbytes);
      if (sent) {
        ++thisuser.downloaded;
        thisuser.dk += (int) ((u.numbytes+1023)/1024);
        ++u.numdloads;
        SETREC(i);
        write(dlf,(void *)&u,sizeof(uploadsrec));
        sprintf(s1,"Downloaded '%s'",u.filename);
        sysoplog(s1);
        nl();
        nl();
        sprintf(s1,"%-6.3f",ratio());
        print("Your ratio is now: ",s1,"");
        if (useron)
          topscreen();
      }
    } else {
      nl();
      nl();
      pl("Not enough time left to D/L.");
      nl();
    }
    if (abort)
      ok=0;
    else
      i=nrecno(s,i);
  }
  closedl();
  if (abort)
    return(-1);
  else
    return(1);
}
/****************************************************************************/


void download()
{
  char s[81];
  int dn;

  nl();
  pl("Download -");
  nl();
  prt(2,"Filename: ");
  input(s,12);
  if (s[0]==0)
    return;
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  align(s);
  if (!try_to_download(s,udir[curdir].subnum,0)) {
    nl();
    pl("Searching all directories.");
    nl();
    dn=0;
    while ((dn<64) && (udir[dn].subnum!=-1)) {
      if (try_to_download(s,udir[dn].subnum,1)<0)
        dn=100;
      else
        dn++;
    }
  }
}


void removefile()
{
  int i,i1,ok,rm,abort,rdlp;
  char ch,s[81],s1[81];
  uploadsrec u;
  userrec uu;

  dliscan();
  nl();
  pl("Enter filename to remove.");
  outstr(":");
  mpl(12);
  input(s,12);
  if (s[0]==0) {
    closedl();
    return;
  }
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  align(s);
  i=recno(s);
  abort=0;
  while ((!hangup) && (i>0) && (!abort)) {
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    if ((dcs()) || ((u.ownersys==0) && (u.ownerusr==usernum))) {
      nl();
      printfileinfo(&u,udir[curdir].subnum);
      prt(2,"Remove (Y/N/Q) : ");
      ch=onek("QNY");
      if (ch=='Q')
        abort=1;
      if (ch=='Y') {
        rdlp=1;
        if (dcs()) {
          prt(5,"Delete file too? ");
          rm=yn();
          if (rm) {
            prt(5,"Remove DL points? ");
            rdlp=yn();
          }
        } else
          rm=1;
        if (rm) {
	  strcpy(s1,(directories[udir[curdir].subnum].path));
          strcat(s1,u.filename);
          unlink(s1);
          if ((rdlp) && (u.ownersys==0)) {
            read_user(u.ownerusr,&uu);
            --uu.uploaded;
            uu.uk -= ((u.numbytes+1023)/1024);
            write_user(u.ownerusr,&uu);
            close_user();
          }
        }
        if (u.mask & mask_extended)
          delete_extended_description(u.filename);
        sprintf(s1,"-%s Removed off of %s",u.filename,
                          directories[udir[curdir].subnum].name);
        sysoplog(s1);
        for (i1=i; i1<numf; i1++) {
          SETREC(i1+1);
          read(dlf,(void *)&u,sizeof(uploadsrec));
          SETREC(i1);
          write(dlf,(void *)&u,sizeof(uploadsrec));
        }
        --i;
        --numf;
        u.numbytes=numf;
        SETREC(0);
        write(dlf,(void *)&u,sizeof(uploadsrec));
      }
    }
    i=nrecno(s,i);
  }
  closedl();
}


void setldate()
{
  struct date d;
  struct time t;
  char s[81];
  int m,dd,y;

  nl();
  nl();
  unixtodos(nscandate,&d,&t);
  nl();
  sprintf(s,"Current limiting date = %02d/%02d/%02d",d.da_mon,d.da_day,(d.da_year-1900));
  pl(s);
  nl();
  pl("Enter new limiting date in the format:");
  pl(" MM/DD/YY");
  outstr(":");
  input(s,8);
  m=atoi(s);
  dd=atoi(&(s[3]));
  y=atoi(&(s[6]))+1900;
  if ((strlen(s)==8) && (m>0) && (m<=12) && (dd>0) && (dd<32) && (y>=1980)) {
    t.ti_min=0;
    t.ti_hour=0;
    t.ti_hund=0;
    t.ti_sec=0;
    d.da_year=y;
    d.da_day=dd;
    d.da_mon=m;
    sprintf(s,"Current limiting date = %02d/%02d/%02d",m,dd,(y-1900));
    nl();
    pl(s);
    nl();
    nscandate=dostounix(&d,&t);
  }
}


void finddescription()
{
  uploadsrec u;
  int i,i1,i2,abort,pty,d,ocd,pts;
  char s[81],s1[81];

  nl();
  nl();
  pl("Find description -");
  nl();
  pl("Enter string to search for in file description:");
  outstr(":");
  input(s1,58);
  if (s1[0]==0)
    return;

  ocd=curdir;
  abort=0;
  num_listed=0;
  for (i=0; (i<64) && (!abort) && (!hangup) && (udir[i].subnum!=-1); i++) {
    i1=udir[i].subnum;
    pts=0;
    if (i1>=32) {
      if (thisuser.nscn2 & (1L << (i1-32)))
        pts=1;
    } else {
      if (thisuser.nscn1 & (1L << i1))
        pts=1;
    }
    pts=1;
    /* remove pts=1 to search only marked directories */
    if (pts) {
      curdir=i;
      dliscan();
      pty=1;
      for (i1=1; (i1<=numf) && (!abort) && (!hangup); i1++) {
        SETREC(i1);
        read(dlf,(void *)&u,sizeof(uploadsrec));
        strcpy(s,u.description);
        for (i2=0; i2<strlen(s); i2++)
          s[i2]=upcase(s[i2]);
        if (strstr(s,s1)!=NULL) {
          if (pty) {
            printtitle(&abort);
            pty=0;
          }
          printinfo(&u,&abort);
        }
      }
      closedl();
    }
  }
  curdir=ocd;
  if ((num_listed) && (!abort)) {
    nl();
    nl();
    sprintf(s,"Files listed: %d",num_listed);
    pl(s);
    nl();
  }
}


int upload_file(char *fn, int dn)
{
  directoryrec d;
  uploadsrec u,u1;
  int i,i1,i2,ok,f;
  char s[81],s1[81],ff[81];
  long l;
  double ti;

  d=directories[dn];
  strcpy(s,fn);
  align(s);
  strcpy(u.filename,s);
  u.ownerusr=usernum;
  u.ownersys=0;
  u.numdloads=0;
  u.filetype=0;
  u.mask=0;
  strcpy(ff,d.path);
  strcat(ff,s);
  f=open(ff,O_RDONLY | O_BINARY);
  l=filelength(f);
  u.numbytes=l;
  close(f);
  strcpy(u.upby,nam1(&thisuser,usernum,syscfg.systemnumber));
  strcpy(u.date,date());
  if (d.mask & mask_PD)
    d.mask=mask_PD;
  strcpy(s,u.filename);
  strcat(s,": ");
  ltoa((((u.numbytes)+1023)/1024),s1,10);
  strcat(s1,"k");
  for (i=0; i<5-strlen(s1); i++)
    strcat(s," ");
  strcat(s,s1);
  strcat(s," :");
  outstr(s);
  inputl(u.description,58);
  if (u.description[0]==0)
    return(0);
  ++thisuser.uploaded;
  thisuser.uk += ((l+1023)/1024);
  time(&l);
  u.daten=l;
  for (i=numf; i>=1; i--) {
    SETREC(i);
    read(dlf,(void *)&u1,sizeof(uploadsrec));
    SETREC(i+1);
    write(dlf,(void *)&u1,sizeof(uploadsrec));
  }
  SETREC(1);
  write(dlf,(void *)&u,sizeof(uploadsrec));
  ++numf;
  u1.numbytes=numf;
  SETREC(0);
  write(dlf,(void *)&u1,sizeof(uploadsrec));
  ++status.uptoday;
  save_status();
  sprintf(s,"+%s uploaded on %s",u.filename,d.name);
  sysoplog(s);
  return(1);
}


int uploadall(int dn)
{
  int i,i1,f1,maxf,ok,ocd;
  char s[81],s1[81];
  struct ffblk ff;
  uploadsrec u;

  dliscan1(dn);
  ocd=curdir;
  curdir=dn;
  nl();
  nl();
  strcpy(s,"*.*");
  strcpy(s1,(directories[dn].path));
  maxf=directories[dn].maxfiles;
  strcat(s1,s);
  f1=findfirst(s1,&ff,0);
  ok=1;
  i1=0;
  while ((f1==0) && (!hangup) && (numf<maxf) && (ok) && (!i1)) {
    strcpy(s,(ff.ff_name));
    align(s);
    i=recno(s);
    if (i==-1) {
      if (!upload_file(s,dn))
        ok=0;
    } else {
      SETREC(i);
      read(dlf,(void *)&u, sizeof(uploadsrec));
      printinfo(&u,&i1);
    }
    f1=findnext(&ff);
  }
  curdir=ocd;
  closedl();
  if (!ok)
    pl("Aborted.");
  if (numf>=maxf)
    pl("directory full.");
  return(i1);
}


void rename_file()
{
  char s[81],s1[81],s2[81],*ss,s3[81],ch;
  int i,cp;
  uploadsrec u;

  nl();
  nl();
  prt(2,"File to rename: ");
  input(s,12);
  if (s[0]==0)
    return;
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  align(s);
  dliscan();
  nl();
  strcpy(s3,s);
  i=recno(s);
  while (i>0) {
    cp=i;
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    nl();
    printfileinfo(&u,udir[curdir].subnum);
    nl();
    prt(5,"Change info for this file (Y/N/Q)? ");
    ch=onek("QNY");
    if (ch=='Q')
      break;
    else if (ch=='N') {
      i=nrecno(s3,cp);
      continue;
    }
    nl();
    prt(2,"New filename? ");
    input(s,12);
    if (!okfn(s))
      s[0]=0;
    if (s[0]) {
      align(s);
      if (strcmp(s,"        .   ")) {
        strcpy(s1,directories[udir[curdir].subnum].path);
        strcpy(s2,s1);
        strcat(s1,s);
        if (exist(s1))
          pl("Filename already in use; not changed.");
        else {
          strcat(s2,u.filename);
          rename(s2,s1);
          if (exist(s1)) {
            ss=read_extended_description(u.filename);
            if (ss) {
              delete_extended_description(u.filename);
              add_extended_description(s,ss);
              farfree(ss);
            }
            strcpy(u.filename,s);
          } else
            pl("Bad filename.");
        }
      }
    }
    nl();
    pl("New description:");
    prt(2,": ");
    inputl(s,58);
    if (s[0]) {
      strcpy(u.description,s);
    }
    ss=read_extended_description(u.filename);
    nl();
    nl();
    prt(5,"Modify extended description? ");
    if (yn()) {
      nl();
      if (ss) {
        prt(5,"Delete it? ");
        if (yn()) {
          farfree(ss);
          delete_extended_description(u.filename);
          u.mask &= ~mask_extended;
        } else {
          u.mask |= mask_extended;
          modify_extended_description(&ss);
          if (ss) {
            delete_extended_description(u.filename);
            add_extended_description(u.filename,ss);
            farfree(ss);
          }
        }
      } else {
        modify_extended_description(&ss);
        if (ss) {
          add_extended_description(u.filename,ss);
          farfree(ss);
          u.mask |= mask_extended;
        } else
          u.mask &= ~mask_extended;
      }
    } else
      if (ss) {
        farfree(ss);
        u.mask |= mask_extended;
      } else
        u.mask &= ~mask_extended;
    SETREC(i);
    write(dlf,(void *)&u,sizeof(uploadsrec));
    i=nrecno(s3,cp);
  }
  closedl();
}


void move_file()
{
  char sx[81],s[81],s1[81],s2[81],ch,*ss;
  int i,i1,ok,d1,d2,done,cp;
  uploadsrec u,u1,u2;
  char *b;

  ok=0;
  nl();
  nl();
  prt(2,"Filename to move: ");
  input(sx,12);
  if (strchr(sx,'.')==NULL)
    strcat(sx,".*");
  align(sx);
  dliscan();
  i=recno(sx);
  if (i<0) {
    nl();
    pl("File not found.");
    closedl();
    return;
  }
  done=0;
  while ((!hangup) && (i>0) && (!done)) {
    cp=i;
    SETREC(i);
    read(dlf,(void *)&u,sizeof(uploadsrec));
    nl();
    printfileinfo(&u,udir[curdir].subnum);
    nl();
    prt(5,"Move this (Y/N/Q)? ");
    ch=onek("QNY");
    if (ch=='Q')
      done=1;
    if (ch=='Y') {
      strcpy(s1,directories[udir[curdir].subnum].path);
      strcat(s1,u.filename);
      do {
        nl();
        nl();
        prt(2,"To which directory? ");
        ss=mmkey(1);
        if (ss[0]=='?')
          dirlist();
      } while ((!hangup) && (ss[0]=='?'));
      d1=-1;
      if (ss[0])
        for (i1=0; i1<64; i1++)
          if (strcmp(udir[i1].keys,ss)==0)
            d1=i1;
      if (d1!=-1) {
        ok=1;
        d1=udir[d1].subnum;
        closedl();
        dliscan1(d1);
        if (recno(u.filename)>0) {
          ok=0;
          nl();
          pl("Filename already in use in that directory.");
        }
        if (numf>=directories[d1].maxfiles) {
          ok=0;
          nl();
          pl("Too many files in that directory.");
        }
        if (freek1(directories[d1].path)<((double)(u.numbytes/1024L)+3)) {
          ok=0;
          nl();
          pl("Not enough disk space to move it.");
        }
        closedl();
        dliscan();
      }
    } else
      ok=0;
    if (ok) {
      --cp;
      for (i1=i; i1<numf; i1++) {
        SETREC(i1+1);
        read(dlf,(void *)&u1,sizeof(uploadsrec));
        SETREC(i1);
        write(dlf,(void *)&u1,sizeof(uploadsrec));
      }
      --numf;
      u1.numbytes=numf;
      SETREC(0);
      write(dlf,(void *)&u1,sizeof(uploadsrec));
      ss=read_extended_description(u.filename);
      if (ss)
        delete_extended_description(u.filename);
      closedl();

      strcpy(s2,directories[d1].path);
      strcat(s2,u.filename);
      dliscan1(d1);
      for (i=numf; i>=1; i--) {
        SETREC(i);
        read(dlf,(void *)&u1,sizeof(uploadsrec));
        SETREC(i+1);
        write(dlf,(void *)&u1,sizeof(uploadsrec));
      }
      SETREC(1);
      write(dlf,(void *)&u,sizeof(uploadsrec));
      ++numf;
      u1.numbytes=numf;
      SETREC(0);
      write(dlf,(void *)&u1,sizeof(uploadsrec));
      if (ss) {
        add_extended_description(u.filename,ss);
        farfree(ss);
      }
      closedl();

      if ((strcmp(s1,s2)!=0) && (exist(s1))) {
        d2=0;
        if ((s1[1]!=':') && (s2[1]!=':'))
          d2=1;
        if ((s1[1]==':') && (s2[1]==':') && (s1[0]==s2[0]))
          d2=1;
        if (d2) {
          rename(s1,s2);
          unlink(s1);
        } else {
          if ((b=malloca(16400))==NULL)
            return;
          d1=open(s1,O_RDONLY | O_BINARY);
          d2=open(s2,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
          i=read(d1,(void *)b,16384);
          while (i>0) {
            write(d2,(void *)b,i);
            i=read(d1,(void *)b,16384);
          }
          close(d1);
          close(d2);
          unlink(s1);
          farfree(b);
        }
      }
      nl();
      pl("File moved.");
    } else
      closedl();
    dliscan();
    i=nrecno(sx,cp);
  }
  closedl();
}

void yourinfodl()
{
  char s[81],s1[81],s2[81],s3[81];

  itoa(thisuser.uploaded,s,10);
  itoa(thisuser.downloaded,s1,10);
  ltoa(thisuser.uk,s2,10);
  ltoa(thisuser.dk,s3,10);
  nl();
  nl();
  print("Uploads  : ",s2,"k in ",s," files","");
  print("Downloads: ",s3,"k in ",s1," files","");
  sprintf(s,"%-6.3f",ratio());
  print("Ratio    : ",s,"");
  itoa(thisuser.dsl,s,10);
  print("Your DSL : ",s,"");
  nl();
}

void l_config_nscan()
{
  int i,abort,i1;
  char s[81];

  abort=0;
  nl();
  pl("Dirs to n-scan marked with '*'");
  nl();
  for (i=0; (i<64) && (udir[i].subnum!=-1) && (!abort); i++) {
    i1=udir[i].subnum;
    if (i1<32) {
      if ((1L << (i1)) & thisuser.nscn1)
        strcpy(s,"* ");
      else
        strcpy(s,"  ");
    } else {
      if ((1L << (i1-32)) & thisuser.nscn2)
        strcpy(s,"* ");
      else
        strcpy(s,"  ");
    }
    strcat(s,(udir[i].keys));
    strcat(s,". ");
    strcat(s,directories[i1].name);
    pla(s,&abort);
  }
  nl();
  nl();
}

void config_nscan()
{
  char *s;
  int i,done,i1;

  l_config_nscan();
  done=0;
  do {
    nl();
    pl("Enter directory identifier, ? to list, or Q to Quit");
    prt(2,"Config: ");
    s=mmkey(1);
    if (s[0])
      for (i=0; i<64; i++)
        if (strcmp(udir[i].keys,s)==0) {
          i1=udir[i].subnum;
          if (i1<32)
            thisuser.nscn1 ^= ((1L) << i1);
          else
            thisuser.nscn2 ^= ((1L) << (i1-32));
        }
    if (strcmp(s,"Q")==0)
      done=1;
    if (strcmp(s,"?")==0)
      l_config_nscan();
  } while ((!done) && (!hangup));
}


void xfer_defaults()
{
  char s[81],s1[81],ch;
  int i,i1,i2,done;

  done=0;
  do {
    outchr(12);
    pl("1. Set N-Scan Directories.");
    pl("2. Set Default Protocol.");
    sprintf(s,"3. N-Scan Transfer after Message Base (%s).",
      thisuser.sysstatus & sysstatus_nscan_file_system?"Yes":"No");
    pl(s);
/*  sprintf(s,"4. Number of lines of extended description to print (%d line%s).", */
/*    thisuser.num_extended,thisuser.num_extended==1?"":"s");                     */
/*  pl(s);   */
    pl("Q. Quit.");
    nl();
    prt(2,"Which? ");
    helpl=32;
    ch=onek("Q123");
    switch(ch) {
      case 'Q':
        done=1;
        break;
      case '1':
        helpl=24;
        config_nscan();
        break;
      case '2':
        nl();
        nl();
        pl("Enter your default protocol, 0 for none.");
        nl();
        helpl=40;
        i=get_protocol(1);
        if (i>=0)
          thisuser.defprot=i;
        break;
      case '3':
        nl();
        nl();
        pl("Do you want to perform a newscan of all selected transfer");
        outstr("directories after an N-scan of the message base? ");
        if (thisuser.sysstatus & sysstatus_nscan_file_system)
          thisuser.sysstatus -= sysstatus_nscan_file_system;
        if (yn())
          thisuser.sysstatus += sysstatus_nscan_file_system;
        break;
      case '4':
        nl();
        nl();
        pl("How many lines of an extended description");
        pl("do you want to see when listing files (0-10)");
        itoa(thisuser.num_extended,s,10);
        print("(Currently set to ",s," lines)","");
        prt(5,"? ");
        helpl=41;
        input(s,3);
        if (s[0]) {
          i=atoi(s);
          if ((i>=0) && (i<=10))
            thisuser.num_extended=i;
        }
        break;
    }
  } while ((!done) && (!hangup));

}

void delbatch(int i)
{
  int i1;

  if (i<numbatch) {
    batchtime -= batchfntime[i];
    --numbatch;
    for (i1=i; i1<=numbatch; i1++) {
      batchdir[i1]=batchdir[i1+1];
      batchfntime[i1]=batchfntime[i1+1];
      strcpy((batchfn[i1]),(batchfn[i1+1]));
    }
  }
}

void listbatch()
{
  char s[81];
  int abort,i;

  abort=0;
  nl();
  sprintf(s,"Files - %d  Time - %s",numbatch,ctim(batchtime));
  pl(s);
  nl();
  for (i=0; (i<numbatch) && (!abort) && (!hangup); i++) {
    sprintf(s,"%d. %s   %s",i+1,batchfn[i],ctim(batchfntime[i]));
    pla(s,&abort);
  }
}

void batchdl()
{
  int i,abort,done,i1,i2,ok,had,rr;
  char s[81],ch,ch2;
  double percent;
  uploadsrec u;

  done=0;
  if (numbatch==0) {
    nl();
    pl("No files in queue.");
    nl();
    return;
  }
  do {
    nl();
    prt(2,"Batch: L,D,R,Q,C,? : ");
    ch=onek("Q?CLRD");
    switch(ch) {
      case '?':
        printmenu(9);
        break;
      case 'Q':
        done=1;
        break;
      case 'L':
        listbatch();
        break;
      case 'R':
        nl();
        prt(2,"Remove which? ");
        input(s,2);
        i=atoi(s);
        if ((i>0) && (i<=numbatch)) {
          delbatch(i-1);
        }
        if (numbatch==0) {
          nl();
          pl("Batch queue empty.");
          nl();
          done=1;
        }
        break;
      case 'C':
        prt(5,"Clear queue? ");
        if (yn()) {
          numbatch=0;
          batchtime=0.0;
          done=1;
          pl("Queue cleared.");
        }
        break;
      case 'D':
	ansic(2);
	nl();
	ansic(0);
	pl("0: Don't Transfer");
	pl("1: Ymodem");
	pl("2: Zmodem");
	pl("3: Ymodem-G");
	pl("4: Lynx");
	pl("5: Puma");
	pl("6: Jbatch");
	pl("7: Super8k");
	nl();
	prt(2,"Protocol : ");
	ch2=onek("01234567");
	switch(ch2)  {
	   case '0':
	      done=1;
	      break;
	   case '1':
        if (!incom)
          break;
        nl();
        prt(5,"Hang up after transfer? ");
        had=yn();
        nl();
        sprintf(s,"Transmitting:  Files - %d  Time - %s",numbatch,ctim(batchtime));
        pl(s);
        nl();
        ok=1;
        rr=0;
        if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
          rr=1;
        if (thisuser.exempt & exempt_ratio)
          rr=0;
        if (rr) {
          nl();
          pl("Sorry, your ratio is too low.");
          nl();
          break;
        }
        do {
          tleft(1);
          if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
            rr=1;
          if (thisuser.exempt & exempt_ratio)
            rr=0;
          if ((nsl()>=batchfntime[0]) && (!rr)) {
            dliscan1(batchdir[0]);
            i=recno((batchfn[0]));
            if (i<=0) {
              delbatch(0);
            } else {
              sprintf(s,"%d files left, Time left = %s\r\n",numbatch,ctim(batchtime));
              outs(s);
              SETREC(i);
              read(dlf,(void *)&u,sizeof(uploadsrec));
              strcpy(s,directories[batchdir[0]].path);
              strcat(s,u.filename);
              xymodem_send(s,&ok,&percent,u.filetype,1,1,1);
              if (ok) {
                ++thisuser.downloaded;
                thisuser.dk += (int) ((u.numbytes+1023)/1024);
                ++u.numdloads;
                SETREC(i);
                write(dlf,(void *)&u,sizeof(uploadsrec));
                strcpy(s,"Downloaded '");
                strcat(s,u.filename);
                strcat(s,"'");
                sysoplog(s);
              }
            }
            closedl();
            delbatch(0);
          } else
            delbatch(0);
        } while ((ok) && (!hangup) && (numbatch>0) && (!rr));
        if ((ok) && (!hangup))
          endbatch();
        if (rr) {
          nl();
          pl("Your ratio is too low to continue the transfer.");
          nl();
        }
        if (had)
          hangup=1;
        done=1;
	break;
      case '2':
	bat_prot(1,&had);
	if(had){
	hangup=1;
	}
	done=1;
	break;
     case '3':
	bat_prot(2,&had);
	if(had){
	hangup=1;
	}
	done=1;
	break;
      case '4':
	bat_prot(3,&had);
	if(had){
	hangup=1;
	}
	done=1;
	break;
      case '5':
	bat_prot(4,&had);
	if(had){
	hangup=1;
	}
	done=1;
	break;
      case '6':
	bat_prot(5,&had);
	if(had){
	hangup=1;
	}
	done=1;
	break;
      case '7':
	bat_prot(6,&had);
	if(had){
	hangup=1;
	}
	done=1;
	break;
    }
    break;
    }
  } while ((!done) && (!hangup));
}

int bat_prot(int t,int *had)
{
   FILE *f;
   int i,abort,done,rr,i2,numb;
   char s[81],xxx[81];
   double percent;
   uploadsrec u;
   if (!incom)
   {
   *had=0;
   return(*had);
   }
   nl();
   prt(5,"Hang up after transfer? ");
   *had=yn();
   nl();
   nl();
   sprintf(s,"%s is currently online",thisuser.name);
   outs(s);
   nl();
   nl();
   sprintf(s,"Transmitting:  Files - %d  Time - %s",numbatch,ctim(batchtime));
   pl(s);
   nl();
   rr=0;
   if ((syscfg.req_ratio>0.0001) && (ratio()<syscfg.req_ratio))
      rr=1;
   if (thisuser.exempt & exempt_ratio)
      rr=0;
   if (rr)  {
      nl();
      pl("Sorry, your ratio is too low.");
      nl();
      *had=0;
      return(*had);
   }
   strcpy(s,"BATCHDWN.LST");
   f=fopen("BATCHDWN.LST","w");
   for (i=0; (i<numbatch); i++)  {
      strcpy(xxx,directories[batchdir[i]].path);
      strcat(xxx,stripfn(batchfn[i]));
      fprintf(f,"%s\n",xxx);
   }
   fclose(f);
   switch(t)
   {
     case 1:
	    strcpy(s,"DSZ port 1 speed 38400");
	    strcat(s," ha both pB4096 sz -Z -r @w:BATCHDWN.LST");
	    break;
     case 2:
	    strcpy(s,"DSZ port 1 speed 38400");
	    strcat(s," ha both pB4096 sb -Z -r @w:BATCHDWN.LST");
	    break;
     case 3:
	    strcpy(s,"LYNX s /s /b /h /1 /38400 @w:BATCHDWN.LST");
	    break;
     case 4:
	    strcpy(s,"puma s @w:batchdwn.lst");
	    break;
     case 5:
	    strcpy(s,"jbatch p1 s38400 ds f @w:batchdwn.lst");
	    break;
     case 6:
	    strcpy(s,"superk p1 s38400 tSB ds f @w:batchdwm.lst");
	    break;
     default:
	    *had=0;
	    return(*had);
   }
   set_protect(0);
   run_external(s);
   topscreen();
   numb=numbatch;
   for (i2=0; i2<numb; i2++)
   {
      dliscan1(batchdir[0]);
      i=recno((batchfn[0]));
      if (i<=0)
      {
	 delbatch(0);
      } else
      {
	 lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
	 read(dlf,(void *)&u,sizeof(uploadsrec));
	 strcpy(s,directories[batchdir[0]].path);
	 strcat(s,u.filename);
	 ++thisuser.downloaded;
	 thisuser.dk += (int) ((u.numbytes+1023)/1024);
	 ++u.numdloads;
	 lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
	 write(dlf,(void *)&u,sizeof(uploadsrec));
	 switch (t)
	 {
	    case 1:
		   strcpy(s,"Downloaded using Zmodem Batch '");
		   break;
	    case 2:
		   strcpy(s,"Downloaded using Ymodem-G Batch '");
		   break;
	    case 3:
		   strcpy(s,"Downloaded using Lynx Batch '");
	 }
	 strcat(s,u.filename);
	 strcat(s,"'");
	 sysoplog(s);
	 closedl();
	 delbatch(0);
      }
   }
   strcpy(s,"BATCHDWN.LST");
   remove(s);
   return(*had);
}

void test_arc()
{
  char s[81],s1[81],s2[81];
  int i,abort,next,i1;
  uploadsrec u;

  nl();
  prt(2,"Archive to test: ");
  mpl(12);
  input(s,12);
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  align(s);
  dliscan();
  abort=0;
  next=0;
  i=recno(s);
  do {
    if (i>0) {
      lseek(dlf,(long) (i*sizeof(uploadsrec)),SEEK_SET);
      read(dlf,(void *)&u,sizeof(uploadsrec));
      if ((compare(u.filename,"????????.ARC"))
      || (compare(u.filename,"????????.ZIP"))) {
	strcpy(s1,directories[udir[curdir].subnum].path);
	strcat(s1,stripfn(u.filename));
	if (strstr(u.filename, ".ARC"))
	  strcpy(s2,"PKUNPAK -T");
	else
	  strcpy(s2,"UNZIP -T");
	strcat(s2," ");
	strcat(s2,s1);
	if (exist(s1)) {
	  nl();
	  nl();
	  ansic(2);
	  prompt("Testing archive integrity of ",u.filename,":","");
	  nl();
	  if (do_external(s2,1))
	    abort=0;
	  checka(&abort,&next);
	}
      }
      i=nrecno(s,i);
    }
  }while ((i>0) && (!hangup) && (!abort));
  closedl();
}

void gif_list()
{
   char s[81],s1[81],s2[81];
   int abort,next;

 nl();
 prt(2,"GIF File(s) to list [no extension]: ");
 mpl(8);
 input(s,8);
 if(strstr(s,".")){
   nl();
   prt(6,"Don't include extension!");
   return;}
 strcat(s,"*.GIF");
 align(s);
 dliscan();
 abort=0;
 next=0;
       strcpy(s1,directories[udir[curdir].subnum].path);
       strcat(s1,s);
       strcpy(s2,"GIFDIR ");
       strcat(s2,s1);
       nl();
       nl();
       ansic(5);
       if (do_external(s2,1))
	 abort=0;
       checka(&abort,&next);
       ansic(0);
closedl();
}

void arc_l()
{
  char s[81],s1[81],s2[81];
  int i,abort,next,i1;
  uploadsrec u;

  nl();
  prt(2,"File for listing: ");
  input(s,12);
  if (strchr(s,'.')==NULL)
    strcat(s,".*");
  if (!okfn(s))
    s[0]=0;
  align(s);
  dliscan();
  abort=0;
  next=0;
  i=recno(s);
  do {
    if (i>0) {
      SETREC(i);
      read(dlf,(void *)&u,sizeof(uploadsrec));
      i1=list_arc_out(stripfn(u.filename),directories[udir[curdir].subnum].path);
      if (i1)
        abort=1;
      checka(&abort,&next);
      i=nrecno(s,i);
    }
  } while ((i>0) && (!hangup) && (!abort));
  closedl();
}

int comparedl(uploadsrec *x, uploadsrec *y, int type)
{
  switch(type) {
    case 0:
      return(strcmp(x->filename,y->filename));
    case 1:
      if (x->daten < y->daten)
        return(-1);
      else
        if (x->daten > y->daten)
          return(1);
        else
          return(0);
  }
}


void quicksort(int l,int r,int type)
{
  register int i,j;
  uploadsrec a,a2,x;

  i=l; j=r;
  SETREC(((l+r)/2));
  read(dlf, (void *)&x,sizeof(uploadsrec));
  do {
    SETREC(i);
    read(dlf, (void *)&a,sizeof(uploadsrec));
    while (comparedl(&a,&x,type)<0) {
      SETREC(++i);
      read(dlf, (void *)&a,sizeof(uploadsrec));
    }
    SETREC(j);
    read(dlf, (void *)&a2,sizeof(uploadsrec));
    while (comparedl(&a2,&x,type)>0) {
      SETREC(--j);
      read(dlf, (void *)&a2,sizeof(uploadsrec));
    }
    if (i<=j) {
      if (i!=j) {
        SETREC(i);
        write(dlf,(void *)&a2,sizeof(uploadsrec));
        SETREC(j);
        write(dlf,(void *)&a,sizeof(uploadsrec));
      }
      i++;
      j--;
    }
  } while (i<j);
  if (l<j)
    quicksort(l,j,type);
  if (i<r)
    quicksort(i,r,type);
}


void sortdir(int dn, int type)
{
  dliscan1(dn);
  if (numf>1)
    quicksort(1,numf,type);
  closedl();
}


void sort_all(int type)
{
  int i;

  for (i=0; (i<64) && (udir[i].subnum!=-1) && (!kbhitb()); i++) {
    nl();
    ansic(1);
    print("Sorting ",directories[udir[i].subnum].name,".","");
    sortdir(i,type);
  }
}


