#include "vardec.h"
#include "fcns.h"
#include <string.h>
#include <io.h>
#include <stdio.h>
#include <sys\stat.h>
#include <fcntl.h>
#include <time.h>
#include <dos.h>
#include <math.h>
#include <stdlib.h>

extern userrec thisuser;
extern int hangup,usernum,incom,numextrn,high_speed;
extern unsigned char checksum;
extern unsigned short crc;
extern char curspeed[81];
extern unsigned int modem_speed,com_speed;
extern configrec syscfg;
extern long timezone;
extern float batchtime,batchfntime[50];
extern int numbatch, batchdir[50];
extern int numbatchul, batchuldir[20];
extern char batchfn[50][13], batchulfn[20][13], batchuldes[20][58];
extern externalrec *externs;
extern configrec syscfg;
extern int checkext[81];

char *stripfn(char *fn)
{
  static char ofn[15];
  int i,i1;
  char s[81];

  i1=-1;
  for (i=0; i<strlen(fn); i++)
    if ((fn[i]=='\\') || (fn[i]==':') || (fn[i]=='/'))
      i1=i;
  if (i1!=-1)
    strcpy(s,&(fn[i1+1]));
  else
    strcpy(s,fn);
  for (i=0; i<strlen(s); i++)
    if ((s[i]>='A') && (s[i]<='Z'))
      s[i]=s[i]-'A'+'a';
  i=0;
  while (s[i]!=0) {
    if (s[i]==32)
      strcpy(&s[i],&s[i+1]);
    else
      ++i;
  }
  strcpy(ofn,s);
  return(ofn);
}


void stripfn1(char *fn)
{
  int i,i1;
  char s[81],s1[81];

  i1=0;
  for (i=0; i<strlen(fn); i++)
    if ((fn[i]=='\\') || (fn[i]==':') || (fn[i]=='/'))
      i1=i;
  strcpy(s1,fn);
  if (i1) {
    strcpy(s,&(fn[i1+1]));
    s1[i1+1]=0;
  } else {
    strcpy(s,fn);
    s1[0]=0;
  }

  for (i=0; i<strlen(s); i++)
    if ((s[i]>='A') && (s[i]<='Z'))
      s[i]=s[i]-'A'+'a';
  i=0;
  while (s[i]!=0) {
    if (s[i]==32)
      strcpy(&s[i],&s[i+1]);
    else
      ++i;
  }
  strcat(s1,s);
  strcpy(fn,s1);
}


void calc_CRC(unsigned char b)
{
  int i;

  checksum += b;

  crc ^= (((unsigned short) (b)) << 8);
  for (i=0; i<8; i++)
    if (crc & 0x8000) {
      crc=(crc << 1);
      crc ^= 0x1021;
    } else
      crc=(crc << 1);
}


char gettimeout(double d, int *abort)
{
  double d1;
  char ch;

  if (comhit())
    return(get1c());
  d1=timer();
  while ((fabs(timer()-d1)<d) && (!comhit()) && (!hangup) && (!*abort)) {
    if (kbhitb()) {
      ch=getchd();
      if (ch==0)
        getchd();
      else
        if (ch==27)
          *abort=1;
    }
    checkhangup();
  }
  if (comhit())
    return(get1c());
  else
    return(0);
}


void send_block(char *b, int type, int ucrc, char bn)
{
  int maxb,i;
  char ch;

  checkhangup();
  switch(type) {
    case 5:
      maxb=128;
      outcomch(1);
      break;
    case 4:
      outcomch(0x81);
      outcomch(bn);
      outcomch(bn ^ 0xff);
      break;
    case 3:
      outcomch(24);
      break;
    case 2:
      outcomch(4);
      break;
    case 1:
      maxb=1024;
      outcomch(2);
      break;
    case 0:
      maxb=128;
      outcomch(1);
  }
  if ((type>1) && (type<5))
    return;
  outcomch(bn);
  outcomch(bn ^ 0xff);
  crc=0;
  checksum=0;
  for (i=0; i<maxb; i++) {
    ch=b[i];
    outcomch(ch);
    calc_CRC(ch);
  }
  if (ucrc) {
     outcomch(crc >> 8);
     outcomch(crc & 0x00ff);
  } else {
    outcomch(checksum);
  }
  dump();
}


char send_b(int f, long pos, int type, char bn, int *ucrc, char *fn, int *terr, int *abort)
{
  char b[1025],ch,x[20],x1[20];
  int i,i1,nb,done,nerr;
  struct ftime ff;
  struct date d;
  struct time t;

  nb=0;
  if (type==0)
    nb=128;
  if (type==1)
    nb=1024;
  if (nb) {
    lseek(f,pos,SEEK_SET);
    i=read(f,(void *)b,nb);
    for (i1=i; i1<nb; i1++)
      b[i1]=0;
  } else
    if (type==5) {
      for (i1=0; i1<128; i1++)
        b[i1]=0;
      nb=128;
      strcpy(b,stripfn(fn));
      ltoa(pos,x,10);
      strcat(x," ");
      getftime(f,&ff);
      t.ti_min=ff.ft_min;
      t.ti_hour=ff.ft_hour;
      t.ti_hund=0;
      t.ti_sec=ff.ft_tsec*2;
      d.da_year=1980+ff.ft_year;
      d.da_day=ff.ft_day;
      d.da_mon=ff.ft_month;
      ltoa(dostounix(&d,&t)-timezone,x1,8);
      strcat(x,x1);
      strcpy(&(b[strlen(b)+1]),x);
      b[127]=(unsigned char) (((int) (pos+127)/128) >> 8);
      b[126]=(unsigned char) (((int) (pos+127)/128) & 0x00ff);
    }
  done=0;
  nerr=0;
  do {
    send_block(b,type,*ucrc,bn);
    ch=gettimeout(5.0,abort);
    if ((ch=='C') && (pos==0))
      *ucrc=1;
    if ((ch==6) || (ch==24))
      done=1;
    else {
      ++nerr;
      ++(*terr);
      if (nerr>=9)
        done=1;
      itoa(nerr,x,10);
      movecsr(69,4);
      outs(x);
      itoa(*terr,x,10);
      movecsr(69,5);
      outs(x);
    }
  } while ((!done) && (!hangup) && (!*abort));
  if (ch==6)
    return(6);
  if (ch==24)
    return(24);
  return(21);
}


int okstart(int *ucrc, int *abort)
{
  char ch;
  double d;
  int ok,done;

  d=timer();
  ok=0;
  done=0;
  while ((fabs(timer()-d)<90.0) && (!done) && (!hangup) && (!*abort)) {
    ch=gettimeout(91.0-d,abort);
    if (ch=='C') {
      *ucrc=1;
      ok=1;
      done=1;
    }
    if (ch==21) {
      *ucrc=0;
      ok=1;
      done=1;
    }
    if (ch==24) {
      ok=0;
      done=1;
    }
  }
  return(ok);
}



void xymodem_send(char *fn, int *sent, double *percent, char ft, int ucrc, int ym, int ymb)
{
  char bn,ch,s[81],s1[10];
  int f,i,i1,abort,terr,xx1,yy1;
  long cp,len;
  double tpb;

  cp=0L;
  bn=1;
  abort=0;
  terr=0;
  f=nopen(fn,0);
  if (f<0) {
    if (!ymb) {
      nl();
      pl("File not found.");
      nl();
    }
    *sent=0;
    *percent=0.0;
    return;
  }
  len=filelength(f);
  if (!len)
    len=1;
  tpb=(12.656) / ((double) (modem_speed)); /* Estimated X-fer Time m0d */

  if (!ymb) {
    nl();
    pl("> Beginning file transmission, ^X to abort.");
  }
  xx1=wherex();
  yy1=wherey();
  movecsr(52,0);
  outs(" Filename :               ");
  movecsr(52,1);
  outs(" Xfer Time:               ");
  movecsr(52,2);
  outs(" File Size:               ");
  movecsr(52,3);
  outs(" Cur Block: 1 - 1k        ");
  movecsr(52,4);
  outs(" Consec Errors: 0         ");
  movecsr(52,5);
  outs(" Total Errors : 0         ");
  movecsr(52,6);
  outs("");
  movecsr(65,0);
  outs(stripfn(fn));
  ltoa((len+127)/128,s,10);
  strcat(s," - ");
  ltoa((len+1023)/1024,s1,10);
  strcat(s,s1);
  strcat(s,"k");
  movecsr(65,2);
  outs(s);

  if (!okstart(&ucrc,&abort))
    abort=1;
  if ((ft) && (!abort) && (!hangup)) {
    ch=send_b(f, len, 4, ft, &ucrc,fn,&terr,&abort);
    if (ch==24)
      abort=1;
    if (ch==21) {
      send_b(f,0L,3,0,&ucrc,fn,&terr,&abort);
      abort=1;
    }
  }
  if ((ym) && (!abort) && (!hangup)) {
    ch=send_b(f, len, 5, 0, &ucrc,fn,&terr,&abort);
    if (ch==24)
      abort=1;
    if (ch==21) {
      send_b(f,0L,3,0,&ucrc,fn,&terr,&abort);
      abort=1;
    }
  }
  while ((!hangup) && (!abort) && (cp<len)) {
    if (ym)
      i=1;
    else
      i=0;
    if ((len-cp)<768L)
      i=0;
    ltoa(cp/128 +1,s,10);
    strcat(s," - ");
    ltoa(cp/1024 +1,s1,10);
    strcat(s,s1);
    strcat(s,"k");
    movecsr(65,3);
    outs(s);
    movecsr(65,1);
    outs(ctim(((double)(len-cp))*tpb));
    movecsr(69,4);
    outs("0");

    ch=send_b(f,cp,i,bn,&ucrc,fn,&terr,&abort);
    if (ch==24)
      abort=1;
    else
      if (ch==21) {
        wait1(18);
        dump();
        send_b(f,0L,3,0,&ucrc,fn,&terr,&abort);
        abort=1;
      } else {
        ++bn;
        if (i)
          cp+=1024;
        else
          cp+=128;
      }
  }
  if ((!hangup) && (!abort))
    send_b(f,0L,2,0,&ucrc,fn,&terr,&abort);
  if (!abort) {
    *sent=1;
    *percent=1.0;
  } else {
    *sent=0;
    if (i)
      cp+=1024;
    else
      cp+=128;
    if (cp>=len)
      *percent=1.0;
    else {
      if (i)
        cp-=1024;
      else
        cp-=128;
      *percent=((double)(cp))/((double)(len));
    }
  }
  close(f);
  movecsr(xx1,yy1);
  if ((*sent) && (!ymb)) {
    pl("> File transmission complete.");
    nl();
  }
}


char modemkey(int *tout)
{
  double d1;
  char ch;

  if (comhit()) {
    ch=get1c();
    calc_CRC(ch);
    return(ch);
  }
  if (*tout)
    return(0);
  d1=timer();
  while ((fabs(timer()-d1)<0.5) && (!comhit()) && (!hangup)) {
    checkhangup();
  }
  if (comhit()) {
    ch=get1c();
    calc_CRC(ch);
    return(ch);
  }
  *tout=1;
  return(0);
}



int receive_block(char *b, unsigned char *bln, int ucrc)
{
  int i,i1,bs,cerr,abort,err,tout,cc1;
  unsigned char ch,bn,bn1,cs1;

  abort=0;
  ch=gettimeout(5.0,&abort);
  err=0;
  if (abort)
    return(6);
  tout=0;
  if (ch==0x81) {
    bn=modemkey(&tout);
    bn1=modemkey(&tout);
    if ((bn ^ bn1)==0xff) {
      b[0]=bn;
      *bln=bn;
      return(8);
    } else
      return(3);
  } else
    if (ch==1) {
      bn=modemkey(&tout);
      bn1=modemkey(&tout);
      if ((bn ^ bn1)!=0xff)
        err=3;
      *bln=bn;
      crc=0;
      checksum=0;
      for (i=0; (i<128) && (!hangup); i++)
        b[i]=modemkey(&tout);
      if ((!ucrc) && (!hangup)) {
        cs1=checksum;
        bn1=modemkey(&tout);
        if (bn1!=cs1) {
          err=2;
        }
      } else if (!hangup) {
        cc1=crc;
        bn=modemkey(&tout);
        bn1=modemkey(&tout);
        if ((bn!=(unsigned char)(cc1 >> 8)) || (bn1!=(unsigned char)(cc1 & 0x00ff)))
          err=2;
      }
      if (tout)
        return(7);
      return(err);
    } else
      if (ch==2) {
        bn=modemkey(&tout);
        bn1=modemkey(&tout);
        crc=0;
        checksum=0;
        if ((bn ^ bn1)!=0xff)
          err=3;
        *bln=bn;
        for (i=0; (i<1024) && (!hangup); i++)
          b[i]=modemkey(&tout);
        if ((!ucrc) && (!hangup)){
          cs1=checksum;
          bn1=modemkey(&tout);
          if (bn1!=cs1)
            err=2;
        } else if (!hangup) {
          cc1=crc;
          bn=modemkey(&tout);
          bn1=modemkey(&tout);
          if ((bn!=(unsigned char)(cc1 >> 8)) || (bn1!=(unsigned char)(cc1 & 0x00ff)))
            err=2;
        }
        if (tout)
          return(7);
        if (err==0)
          return(1);
        else
          return(err);
      } else
        if (ch==24) {
          return(4);
        } else
          if (ch==4) {
            return(5);
          } else
            if (ch==0)
              return(7);
             else
              return(9);
}


void xymodem_receive(char *fn, char *ft, int *received, int ucrc)
{
  char b[1025],x[81],x1[20],ch;
  unsigned char bln;
  unsigned int bn;
  int done,ok,lastcan,lasteot,terr,cerr;
  long pos,reallen,filedatetime,lx;
  int f,i,i1,i2,i3,ox,oy;
  double tpb;
  struct ftime ff;
  struct date d;
  struct time t;
  double d1;

  unlink(fn);
  f=nopen(fn,2);
  ok=1;
  lastcan=0;
  lasteot=0;
  terr=0;
  cerr=0;
  if (f<0) {
    nl();
    nl();
    pl("DOS error - Can't create file.");
    nl();
    *received=0;
    return;
  }
  pos=0L;
  reallen=0L;
  filedatetime=0L;
  bn=1;
  done=0;
  tpb=(12.656) / ((double) (modem_speed)); /* Estimate X-fer time m0d */
  nl();
  pl("> Ready to receive, ^X to abort.");
  ox=wherex();
  oy=wherey();
  movecsr(52,0);
  outs(" Filename :               ");
  movecsr(52,1);
  outs(" Xfer Time:               ");
  movecsr(52,2);
  outs(" File Size:               ");
  movecsr(52,3);
  outs(" Cur Block: 1 - 1k        ");
  movecsr(52,4);
  outs(" Consec Errors: 0         ");
  movecsr(52,5);
  outs(" Total Errors : 0         ");
  movecsr(52,6);
  outs("");
  movecsr(65,0);
  outs(stripfn(fn));
  i=0;
  do {
    if (i++>9) {
      *received=0;
      return;
    }
    if (ucrc)
      outcomch('C');
    else
      outcomch(21);

    d1=timer();
    while ((fabs(timer()-d1)<10.0) && (!comhit()) && (!hangup)) {
      checkhangup();
      if (kbhitb()) {
        ch=getchd();
        if (ch==0)
          getchd();
        else
          if (ch==27) {
            done=1;
            ok=0;
          }
      }
    }
  } while(!comhit() && !hangup);

  do {
    bln=255;
    itoa(cerr,x,10);
    strcat(x,"  ");
    movecsr(69,4);
    outs(x);
    itoa(terr,x,10);
    movecsr(69,5);
    outs(x);
    ltoa(pos/128 +1,x,10);
    strcat(x," - ");
    ltoa(pos/1024 +1,x1,10);
    strcat(x,x1);
    strcat(x,"k");
    movecsr(65,3);
    outs(x);
    if (reallen) {
      movecsr(65,1);
      outs(ctim(((double)(reallen-pos))*tpb));
    }

    i=receive_block(b,&bln,ucrc);
    if ((i==0) || (i==1)) {
      if ((bln==0) && (pos==0L)) {
        i1=strlen(b)+1;
	i3=i1;
	while ((b[i3]>='0') && (b[i3]<='9') && ((i3-i1)<15))
	  x[i3-i1]=b[i3++];
	x[i3-i1]=0;
        reallen=atol(x);
        ltoa((reallen+127)/128,x,10);
        strcat(x," - ");
        ltoa((reallen+1023)/1024,x1,10);
        strcat(x,x1);
        strcat(x,"k");
        movecsr(65,2);
        outs(x);
        while ((b[i1]!=32) && (i1<64))
          ++i1;
        if (b[i1]==32) {
          ++i1;
          while ((b[i1]>='0') && (b[i1]<='8')) {
            filedatetime=(filedatetime*8) + ((long) (b[i1]-'0'));
            ++i1;
          }
          i1+=timezone+5*60*60;
        }
        outcomch(6);
      } else
        if ((bn & 0x00ff)==(unsigned int)bln) {
          lseek(f,pos, SEEK_SET);
          lx=reallen-pos;
          if (i==0)
            i2=128;
          else
            i2=1024;
          if ((((long) i2)>lx) && (reallen))
            i2=(int) lx;
          write(f,(void *)b,i2);
          pos += (long)i2;
          ++bn;
          outcomch(6);
        } else
          if (((bn-1) & 0x00ff)==(unsigned int)bln) {
            outcomch(6);
          } else {
            outcomch(24);
            ok=0;
            done=1;
          }
      cerr=0;
    } else
      if ((i==2) || (i==7) || (i==3)) {
        if ((pos==0L) && (reallen==0L) && (ucrc))
          outcomch('C');
        else
          outcomch(21);
        ++cerr;
        ++terr;
        if (cerr>9) {
          outcomch(24);
          ok=0;
          done=1;
        }
      } else
        if (i==6) {
          ok=0;
          done=1;
          outcomch(24);
        } else
          if (i==4) {
            if (lastcan) {
              ok=0;
              done=1;
              outcomch(6);
            } else {
              lastcan=1;
              outcomch(21);
            }
          } else
            if (i==5) {
	      lasteot=1;
              if (lasteot) {
                done=1;
                outcomch(6);
              } else {
                lasteot=1;
                outcomch(21);
              }
            } else
              if (i==8) {
                *ft=bln;
                outcomch(6);
                cerr=0;
              } else
                if (i==9)
                  dump();
    if (i!=4)
      lastcan=0;
    if (i!=5)
      lasteot=0;
  } while ((!hangup) && (!done));
  movecsr(ox,oy);
  if (ok) {
    if (filedatetime) {
      unixtodos(filedatetime,&d,&t);
      if (d.da_year>=1980) {
        ff.ft_min=t.ti_min;
        ff.ft_hour=t.ti_hour;
        ff.ft_tsec=t.ti_sec/2;
        ff.ft_year=d.da_year-1980;
        ff.ft_day=d.da_day;
        ff.ft_month=d.da_mon;
        setftime(f,&ff);
      }
    }
    close(f);
    *received=1;
  } else {
    close(f);
    unlink(fn);
    *received=0;
  }
}


int extern_prot(int pn, char *fn1, int sending)
{
  char s[81],s1[81],s2[81],fn[81],sx1[21],sx2[21];
  int i,i1;

  i=0;
  for (i1=0; i1<81; i1++) {
    i+=externs[pn].description[i1];
    i+=externs[pn].sendfn[i1];
    i+=externs[pn].receivefn[i1];
  }
  if (i!=checkext[pn]) {
    nl();
    pl("Protocol Corrupted; can't use anymore.");
    nl();
    return(-5);
  }
  if (sending) {
    nl();
    pl("> Beginning file transmission, ^X to abort");
    strcpy(s1,(externs[pn].sendfn));
  } else {
    nl();
    pl("> Ready to receive, ^X to abort.");
    strcpy(s1,(externs[pn].receivefn));
  }
  strcpy(fn,fn1);
  stripfn1(fn);
  ultoa(com_speed,sx1,10);
  sx2[0]='0'+syscfg.primaryport;
  sx2[1]=0;
  stuff_in(s,s1,sx1,sx2,fn,"","");
  if (s[0]) {
    set_protect(0);
    outs("\r\n*> Current user: ");
    outs(nam(&thisuser,usernum));
    outs("\r\n\r\n");
    outs(s);
    outs("\r\n");
    if (incom) {
      i=run_external1(s);
      topscreen();
      return(i);
    } else {
      topscreen();
      return(-5);
    }
  }
}



int get_protocol(int dl)
{
  char s[81],s1[81],oks[81],s2[81],ch;
  int i,i1,i2,prot,maxprot,done;

  if (dl>0)
    strcpy(oks,"Q?012345");
  else
    if (dl<0)
      strcpy(oks,"Q?02345");
    else
      strcpy(oks,"Q?02345");
  maxprot=5;
  prot=thisuser.defprot;
  if ((dl!=1) && (prot==1))
    prot=0;
  done=0;
  for (i1=0; i1<numextrn; i1++) {
    ++maxprot;
    if (((dl) && (externs[i1].sendfn[0])) || ((!dl) && (externs[i1].receivefn[0]))) {
      if (maxprot<10) {
        s1[0]='0'+maxprot;
        s1[1]=0;
      } else {
        s1[0]='A'+maxprot-10;
        s1[1]=0;
      }
      strcat(oks,s1);
    } else
      if (prot==maxprot)
	prot=0;
  }
  if (prot>maxprot)
    prot=0;
  if (prot) {
    strcpy(s,"Protocol (?=list, <C/R>=");
    if (prot<=5) {
      switch(prot) {
        case 1:
          strcat(s,"ASCII");
          break;
        case 2:
	  strcat(s,"Xmodem");
          break;
        case 3:
	  strcat(s,"Xmodem-CRC");
          break;
	case 4:                     /* Default Protocol Prompt m0d */
	  strcat(s,"Ymodem");
          break;
        case 5:
	  strcat(s,"Batch/Bimodem");
          break;
      }
    } else {
      strcat(s,(externs[prot-6].description));
    }
    strcat(s,") : ");
    strcpy(s1,oks);
    strcat(s1,"\r");
  } else {
    strcpy(s,"Protocol (?=list) : ");
    strcpy(s1,oks);
  }
  do {
    nl();
    prt(2,s);
    ch=onek(s1);
    if (ch=='?') {
      nl();
      pl("Q: Abort Transfer(s)");
      pl("0: Don't Transfer");
      if (dl==1)
        pl("1: ASCII");
      pl("2: Xmodem");
      pl("3: Xmodem-CRC");   /* Protocol Menu m0d */
      pl("4: Ymodem");
      pl("5: Add to Batch/Bimodem Queue");
      for (i1=6; i1<=maxprot; i1++) {
        if (i1<10)
          s2[0]=i1+'0';
        else
          s2[0]=i1+'A'-10;
        s2[1]=0;
        strcat(s2,": ");
        strcat(s2,(externs[i1-6].description));
        if (((dl) && (externs[i1-6].sendfn[0])) || ((!dl) && (externs[i1-6].receivefn[0])))
          pl(s2);
      }
      nl();
    } else
      done=1;
  } while ((!done) && (!hangup));
  if (ch==13)
    return(prot);

  /* Auto-Default Protocol m0d */
  if ((ch>='1') && (ch<='9') && (ch-'0' != thisuser.defprot))
     thisuser.defprot = (ch-'0');
  if ((ch>='A') && (ch<='D') && (ch-'A'+10 != thisuser.defprot))
     thisuser.defprot = (ch-'A'+10);

  if ((ch>='0') && (ch<='9'))
    return(ch-'0');
  else
    if (ch=='Q')
      return(-1);
    else
      return(ch-'A'+10);
}


void ascii_send(char *fn, int *sent, double *percent)
{
  char b[2048];
  int i,i1,done,abort,i2,next;
  long pos,max;

  i=nopen(fn,0);
  if (i>0) {
    max=filelength(i);
    if (!max)
      max=1;
    i1=read(i,(void *)b,1024);
    pos=0L;
    abort=0;
    while ((i1) && (!hangup) && (!abort)) {
      i2=0;
      while ((!hangup) && (!abort) && (i2<i1)) {
	checkhangup();
	outchr(b[i2++]);
	checka(&abort,&next);
      }
      pos += (long) i2;
      checka(&abort,&next);
      i1=read(i,(void *)b,1024);
    }
    close(i);
    if (!abort)
      *sent=1;
    else {
      *sent=0;
      thisuser.dk += ((pos+1023L)/1024L);
    }
    *percent=((double) pos)/((double)max);
  } else {
    nl();
    pl("File not found.");
    nl();
    *sent=0;
    *percent=0.0;
  }
}



void send_file(char *fn, int *sent, int *abort, char ft, char *sfn, int dn, long fs)
{
  int i,i1,ok;
  double percent,t;
  char s[81];

  if (dn==-1)
    i=get_protocol(-1);
  else
    i=get_protocol(1);
  ok=0;
  percent=0.0;
  switch(i) {
    case -1:
      *sent=0;
      *abort=1;
      ok=1;
      break;
    case 0:
      *sent=0;
      *abort=0;
      ok=1;
      break;
    case 1:
      *sent=0;
      *abort=0;
      ascii_send(fn,sent,&percent);
      break;
    case 2:
      if (incom)
        xymodem_send(fn,sent,&percent,ft,0,0,0);
      break;
    case 3:
      if (incom)
        xymodem_send(fn,sent,&percent,ft,1,0,0);
      break;
    case 4:
      if (incom)
        xymodem_send(fn,sent,&percent,ft,1,1,0);
      break;
    case 5:
      *sent=0;
      *abort=0;
      ok=1;
      if (numbatch>=50) {
        nl();
	pl("No room left in download queue.");
        nl();
        *sent=0;
        *abort=0;
      } else {           /* Xfer time m0d? */
        t=(12.656) / ((double) (modem_speed)) * ((double)(fs));
        if (nsl()<=(batchtime + t)) {
          nl();
	  pl("Not enough time left in download queue.");
          nl();
          *sent=0;
          *abort=0;
        } else {
          if (dn==-1) {
            nl();
	    pl("Can't add temporary file to download queue.");
            nl();
            *sent=0;
            *abort=0;
          } else {
            batchtime += t;
            strcpy(&(batchfn[numbatch][0]),sfn);
            batchdir[numbatch]=dn;
            batchfntime[numbatch]=t;
            numbatch++;
            nl();
	    pl("File added to download queue.");
	    sprintf(s,"Download Batch: Files - %d  Time - %s",numbatch,ctim(batchtime));
            nl();
            pl(s);
            nl();
            *sent=0;
            *abort=0;
          }
        }
      }
      break;
    default:
      i1=extern_prot(i-6,fn,1);
      *abort=0;
      if (i1==externs[i-6].ok1)
        *sent=1;
      else
        *sent=0;
      break;
  }
  if ((*sent==0) && (ok==0))
    if (percent==1.0) {
      *sent=1;
      add_ass(10,"Aborted on last block");
    } else {
      sprintf(s,"Tried D/L '%s' %3.2f%%",stripfn(fn),percent*100.0);
      sysoplog(s);
    }
}

void receive_file(char *fn, int *received, char *ft, int dn, char *rfn, char *des)
{
  int i;
  char s[81];
  i=get_protocol(0);
  switch(i) {
    case -1:
      *received=0;
      break;
    case 0:
      *received=0;
      break;
    case 2:
      if (incom)
        xymodem_receive(fn,ft,received,0);
      break;
    case 3:
      if (incom)
        xymodem_receive(fn,ft,received,1);
      break;
    case 4:
      if (incom)
        xymodem_receive(fn,ft,received,1);
      break;
    case 5:
      *received=0;
      if (numbatchul>=20) {
        nl();
	pl("No room left in upload queue.");
        nl();
	*received=0;
      } else {  /* Batch Upload m0d */
	    strcpy(&(batchulfn[numbatchul][0]),rfn);
	    batchuldir[numbatchul]=dn;
	    strcpy(&(batchuldes[numbatchul][0]),des);
	    numbatchul++;
            nl();
	    pl("File added to upload queue.");
	    sprintf(s,"Upload Batch: Files - %d",numbatchul);
            nl();
            pl(s);
            nl();
	    *received=-1;
        }
    default:
      if ((i>5) && (incom)) {
        extern_prot(i-6,fn,0);
        *received=exist(fn);
      }
      break;
  }
}



char end_batch1()
{
  char b[128],ch;
  int i,i1,done,nerr;

  for (i1=0; i1<128; i1++)
    b[i1]=0;
  done=0;
  nerr=0;
  i=0;
  do {
    send_block(b,5,1,0);
    ch=gettimeout(5.0,&i);
    if ((ch==6) || (ch==24))
      done=1;
    else {
      ++nerr;
      if (nerr>=9)
        done=1;
    }
  } while ((!done) && (!hangup) && (!i));
  if (ch==6)
    return(6);
  if (ch==24)
    return(24);
  return(21);
}


void endbatch()
{
  char ch;
  int abort,ucrc,terr,xx1,yy1;

  abort=0;
  terr=0;
  xx1=wherex();
  yy1=wherey();
  if (!okstart(&ucrc,&abort))
    abort=1;
  if ((!abort) && (!hangup)) {
    ch=end_batch1();
    if (ch==24)
      abort=1;
    if (ch==21) {
      send_b(0,0L,3,0,&ucrc,"",&terr,&abort);
      abort=1;
    }
/*
    if ((!hangup) && (!abort))
      send_b(0,0L,2,0,&ucrc,"",&terr,&abort);
*/
  }
  movecsr(xx1,yy1);
}


