#include "vardec.h"
#include "fcns.h"
#include "net.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <dir.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <alloc.h>
#include <dos.h>


extern gfiledirrec *gfilesec;
extern int num_sec,hangup,userfile,echo,useron,userfile,usernum,using_modem;
extern int incom,fwaiting,userfile;
extern configrec syscfg;
extern statusrec status;
extern char ctypes[NUM_CTYPES][18];
extern char cdir[81];
extern userrec thisuser;
extern int numextrn, numchain;
extern chainfilerec *chains;
extern externalrec *externs;
extern smalrec *smallist;
extern int num_call_sys,num_ncn,num_sys_list;
extern net_contact_rec *ncn;
extern net_call_out_rec *con;
extern net_system_list_rec *csn;
extern net_interconnect_rec *cnn;
extern messagerec helps[50],menus[30],menus1[30],menus2[30];
extern long last_time_c;
extern unsigned char realsl;

struct line *read_file(char *fn, int *numlines)
{
  char b[1024],s[160],s1[160];
  int f,i,n,nb,cb,sp,oor;
  struct line *l,*l1,*topline;

  *numlines=-1;
  oor=0;
  topline=NULL;
  strcpy(s,syscfg.gfilesdir);
  strcat(s,fn);
  f=nopen(s,1);
  if (f<0) {
    nl();
    pl("File not found.");
    nl();
    return(NULL);
  }
  nb=read(f,(void *)b,1024);
  cb=0;
  sp=0;
  *numlines=0;
  while ((nb) && (!oor)) {
    if (b[cb]==13) {
      s[sp]=0;
      sp=0;
      if (farcoreleft()<10240) {
        nl();
        pl("Ran out of memory.  Not all of file read.");
        nl();
        oor=1;
      } else {
        l1=(struct line *)farmalloc((long) sizeof(struct line));
        strcpy((l1->text),s);
        l1->next=NULL;
        l1->prev=NULL;
        if (topline==NULL) {
          topline=l1;
          l=l1;
        } else {
          l->next=l1;
          l1->prev=l;
          l=l1;
        }
        ++(*numlines);
      }
    } else {
      if (b[cb]!=10)
        s[sp++]=b[cb];
    }
    ++cb;
    if (cb==nb) {
      nb=read(f,(void *)b,1024);
      cb=0;
    }
  }
  return(topline);
}

void kill_file(struct line *topline)
{
  struct line *l,*l1;

  l=topline;
  while (l!=NULL) {
    l1=l->next;
    farfree((void *)l);
    l=l1;
  }
}

void save_file(char *fn, struct line *topline)
{
  int i,f;
  char s[170];
  struct line *l,*l1;

  nl();
  pl("Saving...");
  strcpy(s,syscfg.gfilesdir);
  strcat(s,fn);
  f=nopen(s,3);
  l=topline;
  while (l!=NULL) {
    strcpy(s,(l->text));
    strcat(s,"\r\n");
    write(f,(void *)s,strlen(s));
    l=l->next;
  }
  s[0]=26;
  write(f,(void *)s,1);
  close(f);
}

int printl(int n, struct line *l)
{
  int abort;
  char s[160];

  abort=0;
  if (n<1)
    strcpy(s,"     [TOP]");
  else
    if (l==NULL)
      strcpy(s,"     [END]");
    else
      sprintf(s,"%3d: %s",n,(l->text));
  pla(s,&abort);
  if (abort)
    nl();
  return(abort);
}


void tedit(char *fn)
{
  struct line *topline,*l,*l1,*c,*bottomline;
  int numlines,curline,i,i1,i2,done,save,abort;
  char s[160],s1[160],rollover[160];

  rollover[0]=0;
  thisuser.screenchars -= 5;
  topline=NULL;
  numlines=0;
  curline=0;
  topline=read_file(fn,&numlines);
  itoa(numlines,s,10);
  print(s," lines read in.","");
  nl();
  done=0;
  save=0;
  if (numlines>0) {
    curline=1;
    bottomline=topline;
    while ((bottomline->next)!=NULL)
      bottomline=bottomline->next;
  } else
    curline=0;
  if (numlines<1)
    numlines=0;
  c=topline;
  printl(curline,c);
  do {
    outstr(":");
    input(s,10);
    i=atoi(s);
    if ((s[0]>='0') && (s[0]<='9')) {
      i-=curline;
      if (i==0)
        strcpy(s,"~");
      else
        if (i>0) {
          s[0]='+';
          itoa(i,&(s[1]),10);
        } else {
          itoa(i,s,10);
        }
    }
    if (s[0]==0)
      strcpy(s,"+");
    switch(s[0]) {
      case '?':
        printmenu(11);
        break;
      case 'Q':
        done=1;
        save=0;
        break;
      case 'S':
        done=1;
        save=1;
        break;
      case 'L':
        i=curline;
        l=c;
        while ((l!=NULL) && (printl(i,l)==0)) {
          l=l->next;
          ++i;
        }
        break;
      case 'T':
        c=topline;
        if (topline==NULL)
          curline=0;
        else
          curline=1;
        printl(curline,c);
        break;
      case 'B':
        c=NULL;
        curline=numlines+1;
        printl(curline,c);
        break;
      case '-':
        if (curline) {
          i=atoi(&(s[1]));
          if (i==0)
            i=1;
          for (i1=0; (i1<i) && (curline); i1++) {
            if (c==NULL)
              c=bottomline;
            else
              c=c->prev;
            --curline;
          }
        }
        printl(curline,c);
        break;
      case '+':
        if (curline!=numlines+1) {
          i=atoi(&(s[1]));
          if (i==0)
            i=1;
          for (i1=0; (i1<i) && (curline!=numlines+1); i1++) {
            if (c==NULL)
              c=topline;
            else
              c=c->next;
            ++curline;
          }
        }
        printl(curline,c);
        break;
      case 'D':
        i=atoi(&(s[1]));
        if (i==0)
          i=1;
        for (i1=0; (i1<i) && (c!=NULL); i1++) {
          if (c->prev==NULL)
            if (c->next==NULL) {
              topline=NULL;
              bottomline=NULL;
            } else
              topline=c->next;
          else
            if (c->next==NULL)
              bottomline=c->prev;
          l=c;
          if (c->prev!=NULL)
            c->prev->next=c->next;
          if (c->next!=NULL)
            c->next->prev=c->prev;
          c=c->next;
          farfree((void *)l);
          --numlines;
        }
        printl(curline,c);
        break;
      case 'P':
        printl(curline,c);
        break;
      case 'C':
        nl();
        prt(5,"Clear workspace? ");
        if (yn()) {
          kill_file(topline);
          topline=NULL;
          bottomline=NULL;
          c=NULL;
          numlines=0;
          curline=0;
          pl("File cleared.");
        }
        break;
      case 'I':
        nl();
        pl("Enter '.' on its own line to exit insert mode.");
        i1=0;
        do {
          if (farcoreleft()<10240) {
            nl();
            pl("Not enough memory left to insert anything.");
            nl();
            i1=1;
          } else {
            sprintf(s1,"%3d: ",curline);
            if (curline<1)
              strcpy(s1,"  1: ");
            outstr(s1);
            inli(s1,rollover,150,1);
            if (strcmp(s1,".")==0)
              i1=1;
            else {
              l=(struct line *)farmalloc(sizeof(struct line));
              strcpy((l->text),s1);
              if (c!=NULL) {
                l->next=c;
                if (c->prev!=NULL) {
                  c->prev->next=l;
                  l->prev=c->prev;
                  c->prev=l;
                } else {
                  c->prev=l;
                  l->prev=NULL;
                  topline=l;
                }
              } else {
                if (topline==NULL) {
                  l->prev=NULL;
                  l->next=NULL;
                  topline=l;
                  bottomline=l;
                  curline=1;
                } else
                  if (curline==numlines+1) {
                    l->prev=bottomline;
                    bottomline->next=l;
                    l->next=NULL;
                    bottomline=l;
                  } else {
                    l->prev=NULL;
                    l->next=topline;
                    topline->prev=l;
                    c=topline;
                    topline=l;
                    curline=1;
                  }
              }
              ++numlines;
              ++curline;
            }
          }
        } while ((!i1) && (!hangup));
        break;
    }
  } while ((!done) && (!hangup));
  thisuser.screenchars += 5;
  if (save)
    save_file(fn,topline);
  kill_file(topline);
}


void isr1(int un, char *name)
{
  int cp,i;
  char s[81];
  smalrec sr;

  cp=0;
  while ((cp<status.users) && (strcmp(name,(smallist[cp].name))>0))
    ++cp;
  memmove(&(smallist[cp+1]),&(smallist[cp]),sizeof(smalrec)*(status.users-cp));
  strcpy(sr.name,name);
  sr.number=un;
  smallist[cp]=sr;
  ++status.users;
}



void reset_files()
{
  int i,i1;
  userrec u;
  char s[81];

  status.users=0;

  read_user(1,&u);
  i1=filelength(userfile)/sizeof(userrec)-1;
  for (i=1; i<=i1; i++) {
    read_user(i,&u);
    if ((u.inact & inact_deleted)==0)
      isr1(i,u.name);
    if ((i % 10)==0) {
      itoa(i,s,10);
      pl(s);
    }
  }

  strcpy(s,syscfg.datadir);
  strcat(s,"NAMES.LST");
  i=nopen(s,5);
  if (i<0) {
    printf("%s NOT FOUND.\n",s);
    abort();
  }
  write(i,(void *) (smallist), (sizeof(smalrec) * status.users));
  close(i);

  save_status();
  close_user();
}


void gfiledata(int n, char *s)
{
  char x,y,k,i;
  gfiledirrec r;

  r=gfilesec[n];
  if (r.ar==0)
    x=32;
  else {
    for (i=0; i<16; i++)
      if ((1 << i) & r.ar)
        x='A'+i;
  }
  sprintf(s,"%2d %1c  %-40s  %-8s %-3d %-3d %-3d",
            n,x,r.name,r.filename,r.sl,r.age,r.maxfiles);
}

void showsec()
{
  int abort,i;
  char s[180];

  outchr(12);
  abort=0;
  pla("NN AR Name                                      FN       SL  AGE MAX",
      &abort);
  pla("-- == ----------------------------------------  ======== --- === ---",
      &abort);
  for (i=0; (i<num_sec) && (!abort); i++) {
    gfiledata(i,s);
    pla(s,&abort);
  }
}


int exist_dir(char *s)
{
  int ok;

  cd_to(syscfg.gfilesdir);
  if (chdir(s))
    ok=0;
  else
    ok=1;
  cd_to(cdir);
  return(ok);
}


void modify_sec(int n)
{
  gfiledirrec r;
  char s[81],s1[81],ch,ch2;
  int i,i1,done;

  r=gfilesec[n];
  done=0;
  do {
    outchr(12);
    print("A. Name       : ",r.name,"");
    print("B. Filename   : ",r.filename,"");
    itoa(r.sl,s,10);
    print("C. SL         : ",s,"");
    itoa(r.age,s,10);
    print("D. Min. Age   : ",s,"");
    itoa(r.maxfiles,s,10);
    print("E. Max Files  : ",s,"");
    strcpy(s,"None.");
    if (r.ar!=0) {
      for (i=0; i<16; i++)
        if ((1 << i) & r.ar)
          s[0]='A'+i;
      s[1]=0;
    }
    print("F. AR         : ",s,"");
    nl();
    prt(2,"Which (A-F,Q) ? ");
    ch=onek("QABCDEF");
    switch(ch) {
      case 'Q':done=1; break;
      case 'A':
        nl();
        prt(2,"New Name? ");
        inputl(s,40);
        if (s[0])
          strcpy(r.name,s);
        break;
      case 'B':
	nl();
	if (exist_dir(r.filename)) {
          nl();
	  pl("There is currently a directory for this g-file section.");
	  pl("If you change the filename, the directory will still be there.");
	  nl();
	}
        nl();
        prt(2,"New Filename? ");
        input(s,8);
        if ((s[0]!=0) && (strchr(s,'.')==0)) {
          strcpy(r.filename,s);
	  if (!exist_dir(r.filename)) {
            nl();
	    prt(5,"Create directory for this section? ");
	    if (yn()) {
	      cd_to(syscfg.gfilesdir);
	      mkdir(r.filename);
	      cd_to(cdir);
	    } else {
	      nl();
	      pl("You will have to create the directory manually, then.");
	      nl();
	    }
	  } else {
	    nl();
	    pl("A directory already exists under this filename.");
	    nl();
	  }
	  pausescr();
	}
        break;
      case 'C':
        nl();
        prt(2,"New SL? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<256) && (s[0]))
          r.sl=i;
        break;
      case 'D':
        nl();
        prt(2,"New Min Age? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<128) && (s[0]))
          r.age=i;
        break;
      case 'E':
        nl();
        pl("Max 99 files/section.");
        prt(2,"New Max Files? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<99) && (s[0]))
          r.maxfiles=i;
        break;
      case 'F':
        nl();
        prt(2,"New AR (<SPC>=None) ? ");
        ch2=onek("ABCDEFGHIJKLMNOP ");
        if (ch2==32)
          r.ar=0;
        else
          r.ar=1 << (ch2-'A');
        break;
    }
  } while ((!done) && (!hangup));
  gfilesec[n]=r;
}


void insert_sec(int n)
{
  gfiledirrec r;
  int i,i1,nu;

  for (i=num_sec-1; i>=n; i--)
    gfilesec[i+1]=gfilesec[i];
  strcpy(r.name,"** NEW SECTION **");
  strcpy(r.filename,"NONAME");
  r.sl=10;
  r.age=0;
  r.maxfiles=99;
  r.ar=0;
  gfilesec[n]=r;
  ++num_sec;
  modify_sec(n);
}


void delete_sec(int n)
{
  int i,i1,nu;

  for (i=n; i<num_sec; i++)
    gfilesec[i]=gfilesec[i+1];
  --num_sec;
}


void gfileedit()
{
  int i,i1,i2,done,f;
  char s[81],s1[81],s2[81],ch;

  if (!checkpw())
    return;
  showsec();
  done=0;
  do {
    nl();
    prt(2,"G-files: D:elete, I:nsert, M:odify, Q:uit, ? : ");
    ch=onek("QDIM?");
    switch(ch) {
      case '?':
        showsec();
        break;
      case 'Q':
        done=1;
        break;
      case 'M':
        nl();
        prt(2,"Section number? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<num_sec))
          modify_sec(i);
        break;
      case 'I':
        if (num_sec<32) {
          nl();
          prt(2,"Insert before which section? ");
          input(s,2);
          i=atoi(s);
          if ((s[0]!=0) && (i>=0) && (i<=num_sec))
            insert_sec(i);
        }
        break;
      case 'D':
        nl();
        prt(2,"Delete which section? ");
        input(s,2);
        i=atoi(s);
        if ((s[0]!=0) && (i>=0) && (i<num_sec)) {
          nl();
          strcpy(s1,"Delete ");
          strcat(s1,gfilesec[i].name);
          strcat(s1,"? ");
          prt(5,s1);
          if (yn())
            delete_sec(i);
        }
        break;
    }
  } while ((!done) && (!hangup));
  strcpy(s,syscfg.datadir);
  strcat(s,"GFILE.DAT");
  f=nopen(s,3);
  write(f,(void *)(&gfilesec[0]), num_sec * sizeof(gfiledirrec));
  close(f);
}


int fill_sec(int sn)
{
  gfilerec *g,g1;
  int f1,nf,ok,i,i1,i2,chd;
  char s[81],s1[81];
  struct ffblk ff;

  g=read_sec(sn,&nf);
  sprintf(s1,"%s%s\\*.*",syscfg.gfilesdir,gfilesec[sn].filename);
  f1=findfirst(s1,&ff,0);
  ok=1;
  chd=0;
  while ((f1==0) && (!hangup) && (nf<gfilesec[sn].maxfiles) && (ok)) {
    strcpy(s,(ff.ff_name));
    align(s);
    i=1;
    for (i1=0; i1<nf; i1++)
      if (compare(s,g[i1].filename))
	i=0;
    if (i) {
      strcpy(s1,s);
      strcat(s1," : ");
      prt(2,s1);
      inputl(s1,60);
      if (s1[0]) {
	chd=1;
	i=0;
	while ((strcmp(s1,g[i].description)>0) && (i<nf))
	  ++i;
	for (i1=nf; i1>i; i1--)
	  g[i1]=g[i1-1];
	++nf;
	strcpy(g1.filename,s);
	strcpy(g1.description,s1);
	time(&(g1.daten));
	g[i]=g1;
      } else
	ok=0;
    }
    f1=findnext(&ff);
  }
  if (!ok)
    pl("Aborted.");
  if (nf>=gfilesec[sn].maxfiles)
    pl("Section full.");
  if (chd) {
    sprintf(s,"%s%s.GFL",syscfg.datadir,gfilesec[sn].filename);
    i=nopen(s,3);
    write(i,(void *)g,nf*sizeof(gfilerec));
    close(i);
  }
  farfree(g);
  return(!ok);
}


void checkup(struct ftime *f1, struct ftime *f2, int *tf)
{
  if ((f1->ft_year)>(f2->ft_year))
    *tf=1;
  else
    if (f1->ft_year==f2->ft_year)
      if (f1->ft_month>f2->ft_month)
	*tf=1;
      else
	if (f1->ft_month==f2->ft_month)
	  if (f1->ft_day>f2->ft_day)
	    *tf=1;
	  else
	    if (f1->ft_day==f2->ft_day)
	      if (f1->ft_hour>f2->ft_hour)
		*tf=1;
	      else
		if (f1->ft_hour==f2->ft_hour)
		  if (f1->ft_min>f2->ft_min)
		    *tf=1;
		  else
		    if (f1->ft_min==f2->ft_min)
		      if (f1->ft_tsec>f2->ft_tsec)
			*tf=1;
}


int get_status()
{
  char s[81];
  int statusfile;

  strcpy(s,syscfg.datadir);
  strcat(s,"STATUS.DAT");
  statusfile=nopen(s,7); /* WAS 0 */
  if (statusfile>=0) {
    read(statusfile,(void *)(&status), sizeof(statusrec));
    close(statusfile);
  } else
    save_status();
}


#ifdef OLD

int check_bbsdata()
{
  char s1[81],s2[81],s3[81],s4[81];
  int i,e1,e2,e3,e4,tf,n,tf1;
  struct ftime f1,f2,f3,f4;

  n=0;
  strcpy(s1,syscfg.datadir);
  strcat(s1,"BBSLIST.NET");
  strcpy(s2,syscfg.datadir);
  strcat(s2,"CONNECT.NET");
  strcpy(s3,"CALLOUT.NET");
  strcpy(s4,syscfg.datadir);
  strcat(s4,"BBSDATA.NET");
  e1=exist(s1);
  e2=exist(s2);
  e3=exist(s3);
  e4=exist(s4);
  tf=0;
  if ((e1) && (e2) && (e3)) {
    if (e4) {
      i=nopen(s1,-1);
      getftime(i,&f1);
      close(i);
      i=nopen(s2,-1);
      getftime(i,&f2);
      close(i);
      i=nopen(s3,-1);
      getftime(i,&f3);
      close(i);
      i=nopen(s4,-1);
      getftime(i,&f4);
      close(i);
      tf1=0;
      checkup(&f1,&f4,&tf1);
      if (tf1) {
	tf=1;
	n=1;
      }
      tf1=0;
      checkup(&f2,&f4,&tf1);
      if (tf1) {
	tf=1;
	n=1;
      }
      checkup(&f3,&f4,&tf);
    } else {
      tf=1;
      n=1;
    }
  }
  if (tf) {
    holdphone(1);
#ifdef OLD_WAY
    if (n)
      tf=run_external1("NETWORK3 Y");
    else
      tf=run_external1("NETWORK3");
#else
    if (n)
      shrink_out("NETWORK3 Y",0,0,0,0);
    else
      shrink_out("NETWORK3",0,0,0,0);
#endif
    if (csn!=NULL)
      farfree(csn);
    if (cnn!=NULL)
      farfree(cnn);
    if (con!=NULL)
      farfree(con);
    read_bbs_list();
    read_contacts();
    if (tf<0)
      return(0);
    else
      return(1);
  }
  return(0);
}


#else
/****************************************************************************/
int checkup2(struct ftime *f, char *x)
{
  int q;
  char s[81];
  struct ftime f2;

  if (x=="CALLOUT.NET") /* Added - Local CALLOUT.NET files */
    strcpy(s,x);
  else
  sprintf(s,"%s%s",syscfg.datadir,x);
  q=nopen(s,-1);
  getftime(q,&f2);
  close(q);
  q=0;
  checkup(&f2,f,&q);
  return(q);
}


int check_bbsdata()
{
  char s[81];
  int ok,ok2;
  struct ftime ft;

  sprintf(s,"%sCONNECT.UPD",syscfg.datadir);
  if ((ok=exist(s))==0) {
    sprintf(s,"%sBBSLIST.UPD",syscfg.datadir);
    ok=exist(s);
  }
  if (ok  && status.net_edit_stuff) {
    holdphone(1);
    run_external1("NETEDIT /U");
  } else {
    sprintf(s,"%sBBSDATA.NET",syscfg.datadir);
    ok=nopen(s,-1);
    getftime(ok,&ft);
    close(ok);
    ok=checkup2(&ft,"BBSLIST.NET")||checkup2(&ft,"CONNECT.NET");
    ok2=checkup2(&ft,"CALLOUT.NET");
  }
  if (ok||ok2) {
    sprintf(s,"NETWORK3%s",(ok?" Y":""));
    holdphone(1);

#ifdef OLD_WAY
    ok=run_external1(s);
#else
    shrink_out(s,0,0,0,0);
    ok=0;
#endif

    if (csn!=NULL)
      farfree(csn);
    if (cnn!=NULL)
      farfree(cnn);
    if (con!=NULL)
      farfree(con);
    read_bbs_list();
    read_contacts();
    if (ok>=0)
      return(1);
  }
  return(0);
}
/****************************************************************************/
#endif

void cleanup_net()
{
  char s[81],s1[81];
  int ok,ok2,abort;

  ok2=1;
  abort=0;
  set_protect(0);
  clrscrb();
  while ((ok2) && (!abort)) {
    ok2=0;
    ok=0;
    strcpy(s,syscfg.datadir);
    strcat(s,"P0.NET");
    if (exist(s))
      ok=1;
    strcpy(s,syscfg.datadir);
    strcat(s,"P1.NET");
    if (exist(s))
      ok=1;
    if (ok) {
      holdphone(1);
      hangup=0;
      using_modem=0;
      if (run_external1("NETWORK1")<0)
	abort=1;
      ok2=1;
    }
    strcpy(s,syscfg.datadir);
    strcat(s,"LOCAL.NET");
    if (exist(s)) {
      holdphone(1);
      ok=1;
      hangup=0;
      using_modem=0;
      save_status();
      if (run_external1("NETWORK2")<0)
	abort=1;
      ok2=1;
      get_status();
    }
    if (check_bbsdata())
      ok2=1;
    if (ok2) {
      read_contacts();
      clrscrb();
    }
  }
  holdphone(0);
}

int max_speed(int s1, int s2)
{
  int r1,r2,ms,i,i1;

  r1=-1;
  r2=-1;
  for (i=0; (i<num_sys_list) && ((r1==-1) || (r2==-1)); i++) {
    if (csn[i].sysnum==s1)
      r1=i;
    if (csn[i].sysnum==s2)
      r2=i;
  }
  if ((r1==-1) || (r2==-1))
    return(300);
  ms=csn[r1].speed;
  if (csn[r2].speed<ms)
    ms=csn[r2].speed;
  i1=csn[r1].other & csn[r2].other;
  if (ms<=2400)
    return(ms);
  else
    if ((ms==19200) && (i1 & other_Telebit_19200))
      return(ms);
    else
      if ((ms==9600) && (i1 & (other_Hayes_9600 | other_USR_9600)))
	return(ms);
      else
	return(2400);
}

void do_callout(int sn)
{
  int i,i1,i2;
  char s[81],s1[81];
  float ffl;
  long l;

  time(&l);
  i=-1;
  for (i1=0; i1<num_call_sys; i1++)
    if (con[i1].sysnum==sn)
      i=i1;
  if (i!=-1) {
    strcpy(s,"NETWORK /N");
    itoa(sn,s1,10);
    strcat(s,s1);
    strcat(s," /A");
    if (con[i].options & options_sendback)
      strcat(s,"1 ");
    else
      strcat(s,"0 ");
    if (con[i].macnum) {
      strcat(s,"/M");
      itoa((int)con[i].macnum,s1,10);
      strcat(s,s1);
      strcat(s," ");
    }
    i=con[i].sysnum;
    i2=-1;
    for (i1=0; (i1<num_sys_list) && (i2==-1); i1++)
      if (csn[i1].sysnum==i)
	i2=i1;
    if (i2!=-1) {
      if (csn[i2].numhops!=1)
	return;
      strcat(s,"/P");
      strcat(s,csn[i2].phone);
      strcat(s," /C");
      ffl=csn[i2].cost/216.0;
      ffl *= (float) max_speed(syscfg.systemnumber,con[i2].sysnum);
      sprintf(s1,"%-.3f",ffl);
      strcat(s,s1);
      strcat(s," /S");
      itoa(syscfg.baudrate[syscfg.primaryport],s1,10);
      strcat(s,s1);
      strcat(s," /T");
      ltoa(l,s1,10);
      strcat(s,s1);
      if (strncmp(csn[i2].phone,"000",3)) {
        pl(s);
        save_status();
        holdphone(1);
        wait(2.5);
        run_external(s);
        read_contacts();
        get_status();
        last_time_c=l;
        cleanup_net();
        imodem();
      }
    }
  }
}


int ok_to_call(int i)
{
  int ok;
  struct time ti;
  char ch,h,l;

  ok=((con[i].options & options_no_call)==0);
  if (con[i].options & options_receive_only)
    ok=0;
  _AH=0x2a;
  geninterrupt(0x21);
  ch=_AL;
  gettime(&ti);
  if (con[i].options & options_ATT_night) {
    if ((ch!=0) && (ch!=6)) {
      if ((ti.ti_hour<23) && (ti.ti_hour>=7))
        ok=0;
     }
  }
  if (con[i].options & options_PCP_night) {
    if ((ch!=0) && (ch!=6)) {
      if ((ti.ti_hour<18) && (ti.ti_hour>=6))
        ok=0;
    }
  }

  l=con[i].min_hr;
  h=con[i].max_hr;
  if ((l>-1) && (h>-1) && (h!=l)) {
    if ((h==0) || (h==24)) {
      if (ti.ti_hour<l)
        ok=0;
      else
        if ((ti.ti_hour==l) && (ti.ti_min<12))
          ok=0;
        else
          if ((ti.ti_hour==23) && (ti.ti_min>30))
            ok=0;
    } else
      if ((l==0) || (l==24)) {
        if (ti.ti_hour>=h)
          ok=0;
        else
          if ((ti.ti_hour==h-1) && (ti.ti_min>30))
            ok=0;
          else
            if ((ti.ti_hour==0) && (ti.ti_min<12))
              ok=0;
      } else
        if (h>l) {
          if ((ti.ti_hour<l) || (ti.ti_hour>=h))
            ok=0;
          else
            if ((ti.ti_hour==l) && (ti.ti_min<12))
              ok=0;
            else
              if ((ti.ti_hour==h-1) && (ti.ti_min>30))
                ok=0;
        } else {
          if ((ti.ti_hour>=h) && (ti.ti_hour<l))
            ok=0;
          else
            if ((ti.ti_hour==l) && (ti.ti_min<12))
              ok=0;
            else
              if ((ti.ti_hour==h-1) && (ti.ti_min>30))
                ok=0;
        }
  }

  return(ok);
}



#define WEIGHT 30.0

void fixup_long(long *f, long l)
{
  if (*f>l)
    *f=l;

  if (*f+(86400L*30L)<l)
    *f=l-86400L*30L;
}

void attempt_callout()
{
  int *try,i,i1,i2,i3,index,ok,net_only;
  float *weight,fl,fl1,fl2,ffl;
  long l,l1;
  char ch,s[81],s1[81];
  struct time ti;

  net_only=1;
  if (syscfg.netlowtime!= syscfg.nethightime) {
    if (syscfg.nethightime>syscfg.netlowtime) {
      if ((timer()<=(syscfg.netlowtime*60.0)) || (timer()>=(syscfg.nethightime*60.0)))
        net_only=0;
    } else {
      if ((timer()<=(syscfg.netlowtime*60.0)) && (timer()>=(syscfg.nethightime*60.0)))
        net_only=0;
    }
  } else
    net_only=0;
  time(&l);
  if (last_time_c>l)
    last_time_c=0L;
  if (labs(last_time_c-l)<120)
    return;
  if (last_time_c==0L) {
    last_time_c=l;
    return;
  }
  if ((try=(int *)malloca(sizeof(int)*num_call_sys))==NULL)
    return;
  if ((weight=(float *)malloca(sizeof(float)*num_call_sys))==NULL) {
    farfree(try);
    return;
  }
  index=0;
  fl2=0.0;
  for (i=0; i<num_call_sys; i++) {
    ok=ok_to_call(i);
    i2=-1;
    for (i1=0; i1<num_ncn; i1++)
      if (ncn[i1].systemnumber==con[i].sysnum)
	i2=i1;
    if ((ok) && (i2!=-1)) {
      if (ncn[i2].bytes_waiting==0L)
	if (con[i].call_anyway) {
          l1=(l-ncn[i2].lastcontact+60*3)/3600/24;
	  if (((unsigned char)l1 < con[i].call_anyway) ||
	     ((con[i].options & options_sendback)==0))
            if (!net_only)
              ok=0;
	} else
	  ok=0;
      if (con[i].options & options_once_per_day)
        if (labs(l-ncn[i2].lastcontactsent)<20L*3600L)
	  ok=0;

      fixup_long((long *)&(ncn[i2].lastcontactsent),l);
      fixup_long((long *)&(ncn[i2].lasttry),l);
      if (ok) {
	if (ncn[i2].bytes_waiting==0L)
	  fl=5.0*WEIGHT;
	else
	  fl=1024.0/((float)ncn[i2].bytes_waiting)*WEIGHT*60.0;
        fl1=(float) (l-ncn[i2].lasttry);
	if ((fl<fl1) || (net_only)) {
          try[index]=i;
	  fl1=fl1/fl;
          if (fl1<1.0)
	    fl1=1.0;
	  if (fl1>5.0)
	    fl1=5.0;
          weight[index]=fl1;
	  fl2 += weight[index];
	  ++index;
	}
      }
    }
  }
  if (index) {
    fl=fl2*((float)rand())/32767.0;
    fl1=0.0;
    i1=-1;
    for (i=0; (i<index) && (i1==-1); i++) {
      fl1 += weight[i];
      if (fl1>=fl)
	i1=i;
    }
    if (i1==-1)
      i1=index-1;
    i=try[i1];
    do_callout(con[i].sysnum);
    time(&l);
    last_time_c=l;
  }
  farfree(try);
  farfree(weight);
}

void force_callout()
{
  int i,i1,i2,i3,index,ok,sn;
  float fl,fl1,fl2,ffl;
  long l,l1;
  char ch,s[81],s1[81];
  struct time ti;

  time(&l);
  nl();
  prt(2,"Which system? ");
  input(s,5);
  sn=atoi(s);
  i=-1;
  for (i1=0; i1<num_call_sys; i1++)
    if (con[i1].sysnum==sn)
      i=i1;
  if (i==-1)
    return;
  ok=ok_to_call(i);
  i2=-1;
  for (i1=0; i1<num_ncn; i1++)
    if (ncn[i1].systemnumber==con[i].sysnum)
      i2=i1;
  if (i2==-1)
    return;
  if (ok) {
    if (ncn[i2].bytes_waiting==0L)
      if (!(con[i].options & options_sendback))
	ok=0;
    if (ok) {
      do_callout(sn);
    }
  }
}

void print_net_listing()
{
  int i,i1,i2,abort;
  char s[161],ch;

  abort=0;
  nl();
  pla("  Num  Phone         Name                                     Hop  Next   Cost",&abort);
  pla("-----  ============  ---------------------------------------- === ----- ======",&abort);
  for (i=0; (i<num_sys_list) && (!abort); i++) {
    if (csn[i].forsys!=65535) {
      if (csn[i].other & other_coordinator)
        ch='*';
      else
        ch=' ';
      sprintf(s,"%5d%c %12s  %-40s %3d %5d %6.3f",
        csn[i].sysnum,ch,csn[i].phone,csn[i].name,csn[i].numhops,
        csn[i].forsys,csn[i].cost);
      pla(s,&abort);
    }
  }
}


void read_new_stuff()
{
  int i;
  char s[81];

  if (ncn!=NULL)
    farfree(ncn);
  if (cnn!=NULL)
    farfree(cnn);
  if (csn!=NULL)
    farfree(csn);
  if (con!=NULL)
    farfree(con);
  ncn=NULL;
  cnn=NULL;
  csn=NULL;
  con=NULL;
  read_in_file("MENUS.MSG",(menus),30);
  read_in_file("HELP.MSG",(helps),50);
  for (i=0; i<30; i++) {
    menus1[i].stored_as=0L;
    menus2[i].storage_type=255;
  }
  strcpy(s,syscfg.gfilesdir);
  strcat(s,"MENUSANS.MSG");
  if (exist(s))
    read_in_file("MENUSANS.MSG",(menus1),30);
  strcpy(s,syscfg.gfilesdir);
  strcat(s,"MENUS40.MSG");
  if (exist(s))
    read_in_file("MENUS40.MSG",(menus1),30);

  if (csn!=NULL)
    farfree(csn);
  if (cnn!=NULL)
    farfree(cnn);
  if (con!=NULL)
    farfree(con);
  read_bbs_list();
  read_contacts();
}

void voteprint()
{
  int f,f1,i,i1,i2,i3,nu;
  char s[81],s1[81],s2[81];
  votingrec v;
  char *x;
  userrec u;

  read_user(1,&u);
  nu=filelength(userfile)/sizeof(userrec);
  if ((x=malloca(20*(2+nu)))==NULL)
    return;
  for (i=0; i<nu; i++) {
    read_user(i,&u);
    for (i1=0; i1<19; i1++)
      x[i1+i*20]=u.votes[i1];
  }
  close_user();
  strcpy(s,syscfg.gfilesdir);
  strcat(s,"voting.txt");
  f=nopen(s,3);
  strcpy(s,syscfg.datadir);
  strcat(s,"voting.dat");
  f1=nopen(s,1);
  sprintf(s,"Voting results as of %s\r\n\r\n",date());
  write(f,(void *)s,strlen(s));

  for (i=0; i<20; i++) {
    lseek(f1,((long)i)*sizeof(votingrec),SEEK_SET);
    read(f1,(void *)&v,sizeof(votingrec));
    if (v.numanswers) {
      pl(v.question);
      sprintf(s,"\r\n%s\r\n",v.question);
      write(f,s,strlen(s));
      for (i1=0; i1<v.numanswers; i1++) {
	sprintf(s,"     %s\r\n",v.responses[i1].response);
	write(f,s,strlen(s));
	for (i2=0; i2<status.users; i2++)
          if (x[i+20*smallist[i2].number]==i1+1) {
	    sprintf(s,"          %s #%d\r\n",smallist[i2].name,smallist[i2].number);
	    write(f,s,strlen(s));
	  }
      }
    }
  }

  close(f1);
  close(f);
  farfree(x);
}

/****************************************************************************/

void print_pending_list()
{
  int i,any=0,i1,i2;
  char s[81],ch,s1[81];
  long l;


  if (syscfg.systemnumber) {
    time(&l);

    nl();
    nl();
    pl(" Network data pending transmission:");
    nl();
    pl(" System       Bytes     Hours");
    pl(" ------      -------    -----");

    for (i=0; i<num_ncn; i++) {
      if (ncn[i].bytes_waiting) {
        i2=-1;
        for (i1=0; i1<num_call_sys; i1++)
          if (con[i1].sysnum==ncn[i].systemnumber)
            i2=i1;
        if (i2!=-1) {
          if (ok_to_call(i2))
            ch='*';
          else
            ch=' ';
          any=1;
          if (ncn[i].lastcontactsent)
            ltoa((l-ncn[i].lastcontactsent)/3600,s1,10);
          else
            strcpy(s1,"-NEVER-");
          sprintf(s,"%c%-5d       %7ld    %s",
            ch,
            ncn[i].systemnumber,
            ncn[i].bytes_waiting,
            s1);
          pl(s);
        }
      }
    }
    if (!any)
      pl("--NONE--");
    nl();
    pausescr();
  }
}
